/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* bos530 src/bos/usr/include/aouthdr.h 1.13                              */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 1988,1994          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)17	1.13  src/bos/usr/include/aouthdr.h, cmdld, bos530 8/30/97 09:33:36 */
#ifndef	_H_AHDR
#define _H_AHDR
/*
 * COMPONENT_NAME: cmdld
 *
 * STRUCTURES: aouthdr, aouthdr_64
 *
 * ORIGINS: 3, 27
 *
 */

#include <xcoff32_64.h>

#include <sys/types.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Define the auxiliary header of an XCOFF file.  In general, the auxiliary
   header can be any size, and the length of the auxiliary in any particular
   object file is specified in the f_opthdr field of the XCOFF header.

   Some AIX programs generate auxiliary headers for 32-bit object files that
   end after the data_start field.  The macro _AOUTHSZ_SHORT defines the
   length of such a header.  No auxiliary header is required for an object
   file that is not an executable.

   Executables, however, must have auxiliary headers that include the
   full structure definitions.  The macro _AOUTHSZ_EXEC defines the length
   the auxiliary header must have for an executable.

   In hybrid mode, the following names should be used:

   ============================================================================
   | Basic field or macro name  | 32-bit name          | 64-bit name          |
   ============================================================================
   | magic or o_mflag           | same                 | same                 |
   | vstamp or o_vstamp         | same                 | same                 |
   | tsize or o_tsize           | o_tsize32            | o_tsize64            |
   | dsize or o_dsize           | o_dsize32            | o_dsize64            |
   | bsize or o_bsize           | o_bsize32            | o_bsize64            |
   | entry or o_entry           | o_entry32            | o_entry64            |
   | text_start or o_text_start | o_text_start32       | o_text_start64       |
   | data_start or o_data_start | o_data_start32       | o_data_start64       |
   | o_toc                      | o_toc32              | o_toc64              |
   | o_snentry                  | same                 | same                 |
   | o_sntext                   | same                 | same                 |
   | o_sndata                   | same                 | same                 |
   | o_sntoc                    | same                 | same                 |
   | o_snloader                 | same                 | same                 |
   | o_snbss                    | same                 | same                 |
   | o_algntext                 | same                 | same                 |
   | o_algndata                 | same                 | same                 |
   | o_modtype                  | same                 | same                 |
   | o_cpuflag                  | same                 | same                 |
   | o_cputype                  | same                 | same                 |
   | o_maxstack                 | o_maxstack32         | o_maxstack64         |
   | o_maxdata                  | o_maxdata32          | o_maxdata64          |
   | o_debugger                 | o_debugger32         | o_debugger64         |
   | _AOUTHSZ_SHORT             | _AOUTHSZ_SHORT_32    | none                 |
   | _AOUTHSZ_EXEC              | _AOUTHSZ_EXEC_32     | _AOUTHSZ_EXEC_64     |
   ============================================================================
*/

#ifndef __XCOFF_HYBRID__

#ifdef __XCOFF32__

typedef	struct aouthdr {
	short	magic;		/* flags - how to execute		*/
				/* 0x010B: text & data may be paged	*/
	short	vstamp;		/* version stamp			*/
				/* 1 is only valid value		*/
	_LONG32	tsize;		/* text size in bytes			*/
	_LONG32	dsize;		/* data size in bytes			*/
	_LONG32	bsize;		/* bss size in bytes			*/
	_LONG32	entry;		/* entry point descriptor address	*/
	_ULONG32 text_start;	/* virtual address of beginning of text	*/
	_ULONG32 data_start;	/* virtual address of beginning of data	*/
	/* A short 32-bit auxiliary header can end here. */

	_ULONG32 o_toc;		/* address of TOC			*/
	short	o_snentry;	/* section number for entry point	*/
	short	o_sntext;	/* section number for text		*/
	short	o_sndata;	/* section number for data		*/
	short	o_sntoc;	/* section number for toc		*/
	short	o_snloader;	/* section number for loader		*/
	short	o_snbss;	/* section number for bss		*/
	short	o_algntext;	/* log (base 2) of max text alignment	*/
	short	o_algndata;	/* log (base 2) of max data alignment	*/
	char	o_modtype[2];	/* Module type field, 1L, RE, RO	*/
	uchar	o_cpuflag;	/* bit flags - cputypes of objects	*/
	uchar	o_cputype;	/* executable cpu type identification	*/
	_ULONG32 o_maxstack;	/* max stack size allowed (bytes)	*/
	_ULONG32 o_maxdata;	/* max data size allowed (bytes)	*/
	unsigned int o_debugger;/* Reserved for use by debugger if it	*/
				/* needs a location for a breakpoint.	*/
	_ULONG32 o_resv2[2];	/* reserved fields			*/
} AOUTHDR;

#define _AOUTHSZ_SHORT		(size_t)&(((AOUTHDR *)0)->o_toc)
#define _AOUTHSZ_EXEC		sizeof(AOUTHDR)

#endif /* __XCOFF32__ */

#ifdef __XCOFF64__

typedef	struct _S_(aouthdr) {
	short	magic;		/* flags - how to execute		*/
				/* 0x010B: text & data may be paged	*/
	short	vstamp;		/* version stamp			*/
				/* 1 is only valid value		*/
	unsigned int o_debugger;/* Reserved for use by debugger if it	*/
				/* needs a location for a breakpoint.	*/
	unsigned long long text_start;	/* virtual address of text	*/
	unsigned long long data_start;	/* virtual address of data	*/
	unsigned long long o_toc; /* TOC address */
	short	o_snentry;	/* section number for entry point	*/
	short	o_sntext;	/* section number for text		*/
	short	o_sndata;	/* section number for data		*/
	short	o_sntoc;	/* section number for toc		*/
	short	o_snloader;	/* section number for loader		*/
	short	o_snbss;	/* section number for bss		*/
	short	o_algntext;	/* log (base 2) of max text alignment	*/
	short	o_algndata;	/* log (base 2) of max data alignment	*/
	char	o_modtype[2];	/* Module type field, 1L, RE, RO	*/
	unsigned char o_cpuflag;/* bit flags - cputypes of objects	*/
	unsigned char o_cputype;/* executable cpu type identification	*/
	int	o_resv2[1];
	long long	tsize;	/* text size in bytes	*/
	long long	dsize;	/* data size in bytes	*/
	long long	bsize;	/* bss size in bytes	*/
	long long	entry;	/* entry point address */
	unsigned long long o_maxstack;	/* max stack size allowed */
	unsigned long long o_maxdata;	/* max data size allowed */
	int		o_resv3[4];	/* Reserved */
} _S_(AOUTHDR);

#ifdef __XCOFF32__
#define _AOUTHSZ_EXEC_64	sizeof(_S_(AOUTHDR))
#else
#define _AOUTHSZ_EXEC		sizeof(_S_(AOUTHDR))
#endif

#endif /* __XCOFF64__ */

/* Defines to provide the original COFF field names */
#define	o_tsize		tsize
#define	o_dsize		dsize
#define	o_bsize		bsize
#define	o_entry		entry
#define	o_text_start	text_start
#define	o_data_start	data_start

#else /* __XCOFF_HYBRID__ */

typedef	struct aouthdr {
	short	magic;		/* flags - how to execute		*/
				/* 0x010B: text & data may be paged	*/
	short	vstamp;		/* version stamp			*/
				/* 1 is only valid value		*/
	union {
	    int	_tsize32;	/* text size in bytes			*/
	    unsigned int _debugger64;/* Reserved for use by debugger if	*/
				/* it needs a location for a breakpoint.*/
	} _u2;

#define o_tsize32	_u2._tsize32
#define o_debugger64	_u2._debugger64

	union {
		struct {
			_LONG32	_dsize32; /* data size in bytes		*/
			_LONG32	_bsize32; /* bss size in bytes */
			_LONG32	_entry32; /* entry point descriptor address */
			_ULONG32 _text_start32; /* virtual addr of text */
			_ULONG32 _data_start32; /* virtual addr of data */
			/* A short 32-bit auxiliary header can end here. */
			_ULONG32 _toc32;/* address of TOC		*/
		} _s32;
		struct {
			unsigned long long _text_start64; /* addr of text */
			unsigned long long _data_start64; /* addr of data */
			unsigned long long _toc64; /* TOC addr */
		} _s64;
	} _u1;

#define o_dsize32	_u1._s32._dsize32
#define o_bsize32	_u1._s32._bsize32
#define o_entry32	_u1._s32._entry32
#define o_text_start32	_u1._s32._text_start32
#define o_data_start32	_u1._s32._data_start32
#define o_toc32		_u1._s32._toc32

#define o_text_start64	_u1._s64._text_start64
#define o_data_start64	_u1._s64._data_start64
#define o_toc64		_u1._s64._toc64

	short	o_snentry;	/* section number for entry point	*/
	short	o_sntext;	/* section number for text		*/
	short	o_sndata;	/* section number for data		*/
	short	o_sntoc;	/* section number for toc		*/
	short	o_snloader;	/* section number for loader		*/
	short	o_snbss;	/* section number for bss		*/
	short	o_algntext;	/* log (base 2) of max text alignment	*/
	short	o_algndata;	/* log (base 2) of max data alignment	*/
	char	o_modtype[2];	/* Module type field, 1L, RE, RO	*/
	uchar	o_cpuflag;	/* bit flags - cputypes of objects	*/
	uchar	o_cputype;	/* executable cpu type identification	*/
	unsigned int o_maxstack32; /* max stack size allowed (bytes)	*/
	union {
	    struct {
		_ULONG32 _maxdata32;	/* max data size allowed (bytes)*/
		unsigned int _debugger32;/* Reserved for use by debugger*/
				/* if it needs a location for a breakpoint.*/
	    } _u4;
	    long long	_tsize64;	/* text size in bytes		*/
	} _u3;

#define o_maxdata32	_u3._u4._maxdata32
#define o_debugger32	_u3._u4._debugger32
#define o_tsize64	_u3._tsize64

	long long	o_dsize64;	/* data size in bytes	*/
	/* A 32-bit XCOFF executable must have an auxiliary header that
	   ends here. */
	long long	o_bsize64;	/* bss size in bytes	*/
	long long	o_entry64;	/* entry point address */
	unsigned long long o_maxstack64; /* max stack size allowed */
	unsigned long long o_maxdata64;	 /* max data size allowed */
	int		o_resv3[4];	 /* Reserved */
	/* A 64-bit XCOFF executable must have an auxiliary header the
	   full size. */
} AOUTHDR;

#define _AOUTHSZ_SHORT_32	(size_t)&(((_S_(AOUTHDR) *)0)->o_toc32)
#define _AOUTHSZ_EXEC_32	(size_t)&(((AOUTHDR *)0)->o_bsize64)
#define _AOUTHSZ_EXEC_64	sizeof(AOUTHDR)

#endif /* __XCOFF_HYBRID__ */

/* Defines to provide the original COFF field names */
#define	o_mflag		magic
#define	o_vstamp	vstamp

/*
 * Defines for the flags to identify characteristics of a collection
 * of object files link-edited together
 *	Bit-mapped field of the o_cpuflag field above
 */
#define	TOBJ_SAME	0x80	/* All object files have same cputype field. */
#define	TOBJ_COM	0x40	/* All object files are in a valid cputype */
				/*     subset. */
#define	TOBJ_EMULATE	0x20	/* One or more object files are of a  */
				/* cputype that would require emulated */
				/* instructions on the resultant cputype. */
				/* E.g., PWR objects promoted to PPC. */
#define	TOBJ_COMPAT	0x10	/* One or more object files are TCPU_ANY. */
				/* They have been ignored in determining */
				/* the resultant o_cputype value. */

/*
 * Defines for the POWER and PowerPC CPU Types 
 *    The o_cputype field above
 *    The n_cputype field of C_FILE symbol table entry
 */

#define TCPU_INVALID	0	/* Invalid id - assumes POWER for old objects */
#define TCPU_PPC	1	/* PowerPC common architecture 32 bit mode */
#define TCPU_PPC64	2	/* PowerPC common architecture 64 bit mode */
#define TCPU_COM	3	/* POWER and PowerPC architecture common */
#define TCPU_PWR	4	/* POWER common architecture objects */
#define TCPU_ANY	5	/* Mixture of any incompatable POWER */
				/* and PowerPC architecture implementations */
#define TCPU_601	6	/* 601 implementation of PowerPC architecture */
#define TCPU_603	7	/* 603 implementation of PowerPC architecture */
#define TCPU_604	8	/* 604 implementation of PowerPC architecture */
#define TCPU_PWR1	10	/* RS1 implementation of POWER architecture */
#define TCPU_620	16	/* 620 implementation of PowerPC 64-bit architecture */
#define TCPU_A35	17	/* A35 implementation of PowerPC 64-bit architecture */
#define TCPU_PWRX	224	/* RS2 implementation of POWER architecture */

#ifdef __cplusplus
}
#endif

#endif	/* _H_AHDR */
