/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* bos530 src/bos/usr/include/fenv.h 1.4                                  */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2002,2003          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)73  1.4  src/bos/usr/include/fenv.h, libm, bos530 2/20/03 15:03:05 */

#ifndef _H_FENV
#define _H_FENV

#ifndef _H_STANDARDS
#include <standards.h>
#endif

/*
 * These definitions and interfaces are the standard versions of the
 * definitions and interfaces from <fpxcp.h>.
 */

typedef unsigned int fexcept_t;  /* Same as fpflag_t */

typedef struct {
#ifdef _ALL_SOURCE
    unsigned short rmode; /* Floating point rounding mode */
    unsigned int fpstat;	/* Floating point status register */
    unsigned int trapstate; /* Trapping mode */
    unsigned int reserved1; /* Future use */
    unsigned int reserved2; /* Future use */
#else
    /*
     * These identifiers need to conform to the SUSv3 rules of an 
     * implementation defined type.
     */
    unsigned short __rmode; /* Floating point rounding mode */
    unsigned int __fpstat;        /* Floating point status register */
    unsigned int __trapstate; /* Trapping mode */
    unsigned int __reserved1; /* Future use */
    unsigned int __reserved2; /* Future use */
#endif /* _ALL_SOURCE */
    
} fenv_t;

#define FE_DIVBYZERO	((fexcept_t) 0x04000000)
#define FE_INEXACT	((fexcept_t) 0x02000000)
#define FE_INVALID	((fexcept_t) 0x20000000)
#define FE_OVERFLOW	((fexcept_t) 0x10000000)
#define FE_UNDERFLOW	((fexcept_t) 0x08000000)
#define FE_ALL_EXCEPT   ((fexcept_t) 0x3E000000)

#define FE_DOWNWARD	3
#define FE_TONEAREST	1
#define FE_TOWARDZERO   0
#define FE_UPWARD	2

const fenv_t __fe_def_env = { FE_TONEAREST, 0, 0, 0, 0 };
#define FE_DFL_ENV 	(&__fe_def_env)

extern int feclearexcept(int);
extern int fegetexceptflag(fexcept_t *, int);
extern int feraiseexcept(int);
extern int fesetexceptflag(const fexcept_t *, int);
extern int fetestexcept(int);
extern int fegetround(void);
extern int fesetround(int);
extern int fegetenv(fenv_t *);
extern int feholdexcept(fenv_t *);
extern int fesetenv(const fenv_t *);
extern int feupdateenv(const fenv_t *);

#endif
