/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* bos530 src/bos/kernel/sys/POWER/rosinfo.h 1.7.3.1                      */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 1988,1995          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)50       1.7.3.1  src/bos/kernel/sys/POWER/rosinfo.h, syssi, bos530 12/4/03 09:40:45 */

#ifndef _H_ROSINFO
#define _H_ROSINFO

/*
 * COMPONENT_NAME: (ROSIPL) ros code header file rosinfo.h
 *
 * ORIGINS: 27
 *
 * (C) COPYRIGHT International Business Machines Corp. 1988, 1995
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

#include<sys/types.h>

typedef struct ipl_info {

/* The following entry is reserved for IPL ROM usage.
 * The memory bit map's number of bytes per bit.
 * NOTE: the default size is 16K/bit
 */
  unsigned int     bit_map_bytes_per_bit;

/* The following entry is reserved for IPL ROM usage.
 * The highest addressable real memory address byte+1
 * Note: All real memory addresses below this value are in range, addressing
 *       memory at this address or above will cause an address out of range
 *       exception. The appropriate Segment Register T-bit must be set to zero
 *       in order to address memory.
 */
  unsigned int      ram_size;

/*
 *  The model field contains information which allows software to determine
 *  hardware type, data cache size, and instruction cache size.
 *
 *  The model field is decoded as follows:
 *        0xWWXXYYZZ
 *
 *  case 1: WW = 0x00 This means that the hardware is SGR ss32 or SGR ss64
 *                    (ss is speed in MH). The instruction cache is 8K bytes.
 *          XX = reserved
 *          YY = reserved
 *          ZZ = the model code:
 *                  bits 0 & 1 (low order bits) - indicate style type
 *                        00 = Tower     01 = Desktop
 *                        10 = Rack      11 = Reserved
 *                  bits 2 & 3 - indicate relative speed of processor
 *                        00 = Low       01 = Medium
 *                        10 = High      11 = Very high
 *                  bit 4 - Indicates number of combo chips.
 *                        0 = 2 combo chips
 *                        1 = 1 combo chip
 *                  bit 5 - Indicates the number of DCU's.
 *                        0 = 4 DCU's, data cache is 64 K bytes
 *                        1 = 2 DCU's, data cache is 32 K bytes
 *                  bits 6 & 7 (high order bits) - Reserved.
 *
 *  case 2: WW is nonzero.
 *          WW = 0x01 This means that the hardware is SGR ss32 or SGR ss64
 *                    (ss is speed in MH) -  RS1
 *          WW = 0x02 means the hardware is RSC.
 *          WW = 0x04 means the hardware is RS2 ( POWER2).
 *          WW = 0x08 means the hardware is PowerPC.
 *          XX has the following bit definitions:
 *                  bits 0 & 1 (low order bits) - indicate package type
 *                        00 = Tower     01 = Desktop
 *                        10 = Rack      11 = Entry Server Type
 *		    bit  2 - AIX Hardware Verification Test  Supported (rspc)
 *                  bit  3 - AIX Hardware Error Log Analysis Supported (rspc)
 *                  bits 4 through 7 are reserved.
 *          YY = reserved.
 *          ZZ = the model code.  No further information can be obtained
 *                  from this byte.
 *
 *          The instruction cache K byte size is obtained from entry icache.
 *          The data cache K byte size is obtained from entry dcache.
 *
 */
   unsigned int      model;

/* The following entry is reserved for IPL ROM usage.
 * Power Status and keylock Register Decode. IO Address 0x04000E4
 * This is a 32 bit register:
 *   Power Status     bits   0 to  9.
 *   reserved         bits  10 to 27.
 *   keylock decode   bits  28 to 31 are as follows:
 *                            28 29 30 31
 *                             1  1  X  X   Workstation
 *                             0  1  X  X   Supermini
 *                             0  0  X  X   Expansion
 *                             X  X  1  1   Normal keylock position
 *                             X  X  1  0   Service keylock position
 *                             X  X  0  1   Secure keylock position
 *                             X is don't care
 */
   unsigned int      Power_Status_and_keylock_reg;

/* The next entry is used for system and partition identification. */
  char              sys_part_id[16];          /* identifies sys & partition */

  int             dcache_size;
  int             icache_size;
/*
 * The following entries are copied from the IPL ROM Vital Product Data area.
 * These values are used to determine the machine hardware level.
 */
  char              vpd_processor_serial_number[8];

} IPL_INFO;
#endif
