/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* bos530 src/bos/kernel/sys/trchkid.h 1.96.2.112                         */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 1988,1993          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)08     1.96.2.112  src/bos/kernel/sys/trchkid.h, systrace, bos530 6/26/04 14:59:41 */
/*
 * COMPONENT_NAME:            include/sys/trchkid.h
 *
 * FUNCTIONS: header file for system trace hookwords
 *
 * ORIGINS: 27, 83
 *
 * (C) COPYRIGHT International Business Machines Corp. 1988, 2002
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * LEVEL 1, 5 Years Bull Confidential Information
 */

/* All major hook id's should begin with HKWD_, and all minor hook id's
   should begin with hkwd_.
*/

#ifndef _H_TRCHKID
#define _H_TRCHKID

#include "sys/trcmacros.h"

#define HKWD_TRACE                0x00000000
#define HKWD_TRACE_SYNC           0x00000000
#define HKWD_TRACE_TRCON          0x00100000
#define HKWD_TRACE_TRCOFF         0x00200000
#define HKWD_TRACE_HEADER         0x00300000
#define HKHDR_UTS		  0x1	/* uts data */
#define HKHDR_CMD		  0x2	/* trace command */
#define HKHDR_ALL		  0x3	/* tracing all hooks */
#define HKHDR_INCL		  0x4	/* tracing only these hooks */
#define HKHDR_EXCL		  0x5	/* Exclude these hooks */
#define HKHDR_HKBM		  0x6	/* traced hooks bit map */
#define HKHDR_MSG 		  0xff	/* message */

#define HKWD_TRACE_NULL           0x00400000
#define HKWD_TRACE_LWRAP          0x00500000
#define HKWD_TRACE_TWRAP          0x00600000
#define HKWD_TRACE_UNDEFINED      0x00700000
#define HKWD_TRACE_DEFAULT        0x00800000
#define HKWD_TRACE_ERR            0x00900000
#define HKWD_TRACE_UTIL           0x00A00000
/* Utility hook types */
#define HKUT_TSYNC 		  0x0	/* Timer sync, 32-bit only */
#define HKUT_PID		  0x1	/* process info */
#define HKUT_LDR		  0x2	/* loader info */
#define HKUT_CPID		  0x3	/* current pid info */
#define HKUT_DEV		  0x4	/* device info */
#define HKUT_IP			  0x5	/* IP addr */
#define HKUT_BUFF		  0x6	/* buffer allocation scheme */
#define HKUT_CPUMAP  		  0x7	/* cpu usage map */
#define HKUT_SYM		  0xc	/* symbol address */
#define HKUT_TIME		  0x25c	/* Time conversion data */
#define HKUT_CPUFILE		  0x10	/* id/name for cpu file */
#define HKUT_CPUF2  		  0x11	/* base logfile for this cpu file */
#define HKUT_CPUS		  0x12	/* total and traced # cpus */
#define HKUT_LDT 		  0x13	/* indicate large data types */
#define HKUT_REGS 		  0x14	/* programmable registers */
#define HKUT_IVALS 		  0x15	/* initial register values */
#define HKWD_6432	          0x00B00000	/* 64-bit hook in 32-bit trc */

#define HKWD_6432	          0x00B00000	/* 64-bit hook in 32-bit trc */

#define HKWD_USER1                0x01000000
#define HKWD_USER2                0x02000000
#define HKWD_USER3                0x03000000
#define HKWD_USER4                0x04000000
#define HKWD_USER5                0x05000000
#define HKWD_USER6                0x06000000
#define HKWD_USER7                0x07000000
#define HKWD_USER8                0x08000000
#define HKWD_USER9                0x09000000
#define HKWD_USERA                0x0a000000
#define HKWD_USERB                0x0b000000
#define HKWD_USERC                0x0c000000
#define HKWD_USERD                0x0d000000
#define HKWD_USERE                0x0e000000
#define HKWD_USERAIX              0x0f000000

/*
 * These hooks were assigned at one time but are no longer used.
 */

#define HKWD_KERN                 0x10000000
#define HKWD_KERN_FLIH            0x10000000
#define HKWD_KERN_SVC             0x10100000    /* common SVC entry */
#define HKWD_KERN_SLIH            0x10200000
#define HKWD_KERN_SLIHRET         0x10300000
#define HKWD_KERN_SYSCRET         0x10400000    /* common SVC return */
#define HKWD_KERN_LVM             0x10500000    /* LVM bad blk/resync flow */
#define HKWD_KERN_DISPATCH        0x10600000
#define HKWD_LFS_LOOKUP           0x10700000    /* lookuppn */
#define HKWD_SYSC_LFS             0x10800000    /* file system system call */
#define HKWD_KERN_LFS             0x10900000
#define HKWD_KERN_PFS             0x10A00000
#define HKWD_KERN_LVMSIMP         0x10B00000    /* LVM simple request flow */
#define HKWD_KERN_IDLE            0x10C00000    /* Dispatching idle process */
#define HKWD_KERN_VFSINO          0x10d00000
#define HKWD_KERN_RELOCK          0x10e00000	/* ownership games wi RQ lock */
#define HKWD_KERN_EOF             0x10f00000
#define HKWD_KERN_STDERR          0x11000000
#define HKWD_KERN_LOCKF           0x11100000
#define HKWD_KERN_LOCK            0x11200000	
#define HKWD_KERN_UNLOCK          0x11300000	
#define HKWD_KERN_LOCKALLOC       0x11400000	
#define HKWD_KERN_SETRECURSIVE    0x11500000	

#define HKWD_KERN_XMALLOC         0x11600000
#define HKWD_KERN_XMFREE          0x11700000
#define HKWD_KERN_FORKCOPY        0x11800000
#define HKWD_KERN_PIDSIG          0x11900000
#define HKWD_KERN_RCVSIGNAL       0x11a00000
#define HKWD_KERN_P_SLIH          0x11c00000
#define HKWD_KERN_SIG_SLIH        0x11d00000
#define HKWD_KERN_ISSIG           0x11e00000
#define HKWD_KERN_SORQ            0x11f00000
#define HKWD_KERN_EXTINTFLIH      0x12000000
#define HKWD_KERN_RESUME          0x20000000
#define HKWD_KERN_HFT             0x20100000
#define HKWD_KERN_KTSM            0x20200000
#define HKWD_KERN_CON             0x20300000
#define HKWD_KERN_SCHED_SWAPIN	  0X20400000
#define HKWD_KERN_SCHED_SWAPOUT   0X20500000
#define HKWD_KERN_SCHED_POST	  0x20600000
#define HKWD_KERN_SCHED		  0x20700000
#define HKWD_KERN_SCHED_STAT	  0x20800000
#define HKWD_KERN_SCHED_STAT1	  0x20900000
#define HKWD_KERN_SCRUB_DISABLE	  0x20A00000
#define HKWD_KERN_SCRUB_ENABLE	  0x20B00000
#define HKWD_KERN_SCRUB_SEG	  0x20C00000
#define HKWD_KERN_SCRUB_SOFT	  0x20D00000
#define HKWD_KERN_LOCKL           0x20E00000
#define HKWD_KERN_UNLOCKL         0x20F00000
#define HKWD_KERN_INITP		  0x21000000
#define HKWD_KERN_PHANTOM_EXTINT  0x47F00000
#define HKWD_KERN_IOPATH_DATA	  0x49100000

/*
 * "sub-hookids"
 */
#define hkwd_SYSC_FULLSTAT  1
#define hkwd_SYSC_LOCKFX    2
#define hkwd_SYSC_STAT      3
#define hkwd_SYSC_MKNOD     4
#define hkwd_SYSC_ACCESS    5
#define hkwd_SYSC_CHOWN     6
#define hkwd_SYSC_CHOWNX    7
#define hkwd_SYSC_CLOSEX    8
#define hkwd_SYSC_OPENX     9
#define hkwd_SYSC_FCHMOD    10
#define hkwd_SYSC_FCHOWN    11
#define hkwd_SYSC_FCHOWNX   12
#define hkwd_SYSC_FCLEAR    14
#define hkwd_SYSC_FSYNC     15
#define hkwd_SYSC_FTRUNCATE 16
#define hkwd_SYSC_TRUNCATE  17
#define hkwd_SYSC_IOCTLX    18
#define hkwd_SYSC_READX     19
#define hkwd_SYSC_WRITEX    20
#define hkwd_SYSC_LSEEK     21

#define hkwd_VMUIOMOVE_READ	0
#define hkwd_VMUIOMOVE_WRITE	1

#define hkwd_PFS_RDWR       1
#define hkwd_PFS_READI      2
#define hkwd_PFS_WRITEI     3

/* JFS trace hooks
 */
#define HKWD_DIO	0x3B100000	/* JFS: General Direct IO events   */
#define HKWD_DIO_IO	0x3B200000	/* JFS: Direct IO startio/iodone   */
#define HKWD_DIO_PSEG	0x3B300000	/* JFS: Direct IO requests demoted */

#define hkwd_DIO_JMOVE		1	/* HKWD_DIO		*/	
#define hkwd_DIO_PSEG		2	/* HKWD_DIO_PSEG	*/
#define hkwd_DIO_PSEG_WRITE	3	/* HKWD_DIO_PSEG	*/
#define hkwd_DIO_PSEG_IOWAIT	4	/* HKWD_DIO_PSEG	*/
#define hkwd_DIO_XON		5	/* HKWD_DIO		*/
#define hkwd_DIO_XOFF		6	/* HKWD_DIO		*/
#define hkwd_DIO_STARTIO	7	/* HKWD_DIO_IO		*/
#define hkwd_DIO_STARTIO_ADSPC	8	/* HKWD_DIO_IO		*/
#define hkwd_DIO_STARTIO_ADSPC2	9	/* HKWD_DIO_IO		*/
#define hkwd_DIO_IODONE		10	/* HKWD_DIO_IO		*/
#define hkwd_DIO_IODONE_ERROR	11	/* HKWD_DIO		*/
#define hkwd_DIO_STARTIO_MULTI  12	/* HKWD_DIO_IO		*/
#define hkwd_DIO_STARTIO_SIDS   13	/* HKWD_DIO_IO		*/

#define LOCK_TAKEN          1
#define LOCK_MISS           2
#define LOCK_RECURSIVE      3
#define LOCK_BUSY      	    4

#define SETRECURSIVE        1
#define CLEARRECURSIVE      2

#define HKWD_JFS_VNC	0x3EC00000	/* JFS: vnode cache hooks: not */
					/* enabled in shipped kernel   */
#define hkwd_JFS_VNC_FIDTOVP_ENTER              1
#define hkwd_JFS_VNC_FIDTOVP_EXIT               2
#define hkwd_JFS_VNC_ENTER_ENTER                3
#define hkwd_JFS_VNC_ENTER_EXIT                 4
#define hkwd_JFS_VNC_RELE_ENTER                 5
#define hkwd_JFS_VNC_RELE_EXIT                  6
#define hkwd_JFS_VNC_RELE_NOT_FOUND             7
#define hkwd_JFS_VNC_RELE_NULL_VP               8
#define hkwd_JFS_VNC_PURGE_ENTER                9
#define hkwd_JFS_VNC_PURGE_RELE                 10
#define hkwd_JFS_VNC_PURGE_EXIT                 11
#define hkwd_JFS_VNC_PURGE_FOUND                12

#define HKWD_JFS_DNLC	0x3ED00000	/* JFS: name cache hooks: not */
					/* enabled in shipped kernel  */
					
/*
 * J2 hook and sub-hook ids
 */    
#define HKWD_KERN_J2      0x3F700000    /* JFS2: vnode operation events */
#define hkwd_J2_RDWR            1
#define hkwd_J2_READI           2
#define hkwd_J2_WRITEI          3
#define hkwd_J2_CLOSE           4
#define hkwd_J2_IOPEN           5
#define hkwd_VFS_INO		6

#define HKWD_KERN_J2PAGER 0x3F800000 	/* JFS2: pager events */
#define hkwd_J2_PAGEIN          1
#define hkwd_J2_PAGEOUT         2
#define hkwd_J2_READAHEAD       3

#define HKWD_IO_J2	  0x59B00000	/* JFS2: regular I/O */
#define hkwd_IO_READ		1
#define hkwd_IO_WRITE		2
#define hkwd_DIO_DEMOTED	3
#define hkwd_DEVSTRAT		4

#define HKWD_DIO_J2	  0x59C00000	/* JFS2: direct I/O */
#define hkwd_DIO_CLEAR		1
#define hkwd_DIO_SET		2
#define	hkwd_DIO_READ		3
#define	hkwd_DIO_WRITE		4
#define hkwd_DIO_MOVE		5
#define hkwd_J2DIO_IODONE	6
#define hkwd_DIODONE_ERR	7

/*
 * LVM device driver sub hookids
 *
 * #defines with a "X" in the comment are traced with "HKWD_KERN_LVMSIMP"
 * major hook.  All others use "HKWD_KERN_LVM".  This allows for better
 * performance filtering.
 */
#define hkwd_LVM_PEND           1       /* End of physical request      X */
#define hkwd_LVM_PSTART         2       /* Start of physical request    X */
#define hkwd_LVM_RELOCINGBLK    3       /* Encountered relocated blk      */
#define hkwd_LVM_OLDBADBLK      4       /* Old bad block                  */
#define hkwd_LVM_BADBLKDONE     5       /* Blk relocation complete        */
#define hkwd_LVM_NEWBADBLK      6       /* New bad block found            */
#define hkwd_LVM_SWRELOC        7       /* Software relocating bad blk    */
#define hkwd_LVM_RESYNCPP       10      /* Resyncing LP mirrors           */
#define hkwd_LVM_LSTART         11      /* Start of logical request     X */
#define hkwd_LVM_RBLOCKED       12      /* request blocked - conflicts  X */
#define hkwd_LVM_LEND           13      /* End of logical request       X */
#define hkwd_LVM_OPEN           14      /* LV open                        */
#define hkwd_LVM_CLOSE          15      /* LV close                       */
#define hkwd_LVM_READ           16      /* LV character device read       */
#define hkwd_LVM_WRITE          17      /* LV character device write      */
#define hkwd_LVM_IOCTL          18      /* LVM device driver ioctl        */
#define hkwd_LVM_UPD_BBDIR      19      /* Update BB directory. pb queued */
#define hkwd_LVM_BBDIREND       20      /* Iodone for BB directory I/O    */
#define hkwd_LVM_BBDIROP        21      /* Continue BB directory operation*/
#define hkwd_LVM_BBADD          22      /* Add BB directory entry on disk */
#define hkwd_LVM_BBDEL          23      /* Delete BB dir entry on disk    */
#define hkwd_LVM_BBUPD          24      /* Update BB dir entry on disk    */
#define hkwd_LVM_BBDIRDONE      25      /* Completion of BB dir updating  */
#define hkwd_LVM_SA_RTN         30      /* return requests to callers     */
#define hkwd_LVM_SA_CONFIG      31      /* hd_config req for VGSA wheel   */
#define hkwd_LVM_CA_CHKCACH     32      /* check for a cache hit          */
#define hkwd_LVM_CA_CHKHIT      33      /* got a cache hit                */
#define hkwd_LVM_CA_WRT         34      /* start cache writes             */
#define hkwd_LVM_CA_WEND        35      /* cache write end                */
#define hkwd_LVM_MWCCWCOMP      36      /* MWCC write done. sched pending */
#define hkwd_LVM_CA_CLNUP       37      /* flush MWCC cache               */
#define hkwd_LVM_CA_TERM        38      /* logical cached request finished*/
#define hkwd_LVM_MVHLD          39      /* cache hold queue to pending    */
#define hkwd_LVM_SCHEDAVOID     40      /* scheduler called after avoiding*/
#define hkwd_LVM_IN_CONC	41	/* enter hd_concurrent		  */
#define hkwd_LVM_OUT_CONC	42	/* exit hd_concurrent		  */
#define hkwd_LVM_IN_CONCREG	43	/* enter hd_concurrent_register	  */
#define hkwd_LVM_OUT_CONCREG	44	/* exit hd_concurrent_register	  */
#define hkwd_LVM_IN_CNCDREG	45	/* enter hd_concurrent_deregister */
#define hkwd_LVM_OUT_CNCDREG	46	/* exit hd_concurrent_deregister  */
#define hkwd_LVM_IN_CFGD2VGPV	47	/* enter config_dev2vgpv	  */
#define hkwd_LVM_OUT_CFGD2VGPV	48	/* exit config_dev2vgpv		  */
#define hkwd_LVM_IN_D2VGPV	49	/* enter dev2vgpv		  */
#define hkwd_LVM_OUT_D2VGPV	50	/* exit dev2vgpv		  */
#define hkwd_LVM_IN_SCMDINTR	51	/* enter hd_send_cmd_intr	  */
#define hkwd_LVM_OUT_SCMDINTR	52	/* exit hd_send_cmd_intr	  */
#define hkwd_LVM_IN_CONCINTR	53	/* enter hd_concurrent_interrupt  */
#define hkwd_LVM_OUT_CONCINTR	54	/* exit hd_concurrent_interrupt   */
#define hkwd_LVM_IN_CNCINTMSG	55
#define hkwd_LVM_OUT_CNCINTMSG	56
#define hkwd_LVM_IN_CSYNCINT	57
#define hkwd_LVM_OUT_CSYNCINT	58
#define hkwd_LVM_IN_LCAKNKRMSG	59
#define hkwd_LVM_OUT_LCAKNKRMSG	60
#define hkwd_LVM_IN_LCRQRCMSG	61
#define hkwd_LVM_OUT_LCRQRCMSG	62
#define hkwd_LVM_IN_CSYNCRCVCM	63
#define hkwd_LVM_OUT_CSYNCRCVCM	64
#define hkwd_LVM_IN_CNCSYNCRCV	65
#define hkwd_LVM_OUT_CNCSYNCRCV	66
#define hkwd_LVM_IN_SNDMSGALL	67
#define hkwd_LVM_OUT_SNDMSGALL	68
#define hkwd_LVM_IN_LLCWAKE	69
#define hkwd_LVM_OUT_LLCWAKE	70
#define hkwd_LVM_IN_LLCBOWOW	71
#define hkwd_LVM_OUT_LLCBOWOW	72
#define hkwd_LVM_IN_LLCARB	73
#define hkwd_LVM_OUT_LLCARB	74
#define hkwd_LVM_IN_SENDMSG	75
#define hkwd_LVM_OUT_SENDMSG	76
#define hkwd_LVM_IN_SNDCMDIO	77
#define hkwd_LVM_OUT_SNDCMDIO	78
#define hkwd_LVM_IN_SNDCMDW	79
#define hkwd_LVM_OUT_SNDCMDW	80
#define hkwd_LVM_IN_SENDCMD	81
#define hkwd_LVM_OUT_SENDCMD	82
#define hkwd_LVM_IN_CSYNCCLN	83
#define hkwd_LVM_OUT_CSYNCCLN	84
#define hkwd_LVM_IN_CSYNCWD	85
#define hkwd_LVM_OUT_CSYNCWD	86
#define hkwd_LVM_IN_CNCRSTRT	87
#define hkwd_LVM_OUT_CNCRSTRT	88
#define hkwd_LVM_IN_CNCBSY	89
#define hkwd_LVM_OUT_CNCBSY	90
#define hkwd_LVM_IN_CNCSTOP	91
#define hkwd_LVM_OUT_CNCSTOP	92
#define hkwd_LVM_IN_CNCKEXT	93
#define hkwd_LVM_OUT_CNCKEXT	94
#define hkwd_LVM_IN_CNCCFGSEG	95
#define hkwd_LVM_OUT_CNCCFGSEG	96
#define hkwd_LVM_IN_CNCKADDPV	97
#define hkwd_LVM_OUT_CNCKADDPV	98
#define hkwd_LVM_IN_CNCCFGWD	99
#define hkwd_LVM_OUT_CNCCFGWD	100
#define hkwd_LVM_IN_CNCACKWT	101
#define hkwd_LVM_OUT_CNCACKWT	102
#define hkwd_LVM_IN_CNCSNDCFG	103
#define hkwd_LVM_OUT_CNCSNDCFG	104
#define hkwd_LVM_IN_DEQCFG	105
#define hkwd_LVM_OUT_DEQCFG	106
#define hkwd_LVM_IN_ENQCFG	107
#define hkwd_LVM_OUT_ENQCFG	108
#define hkwd_LVM_IN_CNCSETID	109
#define hkwd_LVM_OUT_CNCSETID	110
#define hkwd_LVM_IN_CNCCFGDMN	111
#define hkwd_LVM_OUT_CNCCFGDMN	112
#define hkwd_LVM_IN_CFGDMN	113
#define hkwd_LVM_OUT_CFGDMN	114
#define hkwd_LVM_IN_CNCCFGGETB	115
#define hkwd_LVM_OUT_CNCCFGGETB	116
#define hkwd_LVM_IN_FINDDUPS	117
#define hkwd_LVM_OUT_FINDDUPS	118
#define hkwd_LVM_IN_CNCFGRCVM	119
#define hkwd_LVM_OUT_CNCFGRCVM	120
#define hkwd_LVM_IN_DEV2VG	121
#define hkwd_LVM_OUT_DEV2VG	122
#define hkwd_LVM_IN_CNCCFGIODN	123
#define hkwd_LVM_OUT_CNCCFGIODN	124
#define hkwd_LVM_IN_CNCRDALCFG	125
#define hkwd_LVM_OUT_CNCRDALCFG	126
#define hkwd_LVM_IN_CNCFGRDCFG	127
#define hkwd_LVM_OUT_CNCFGRDCFG	128
#define hkwd_LVM_IN_CNCFGWRTAL	129
#define hkwd_LVM_OUT_CNCFGWRTAL	130
#define hkwd_LVM_IN_CNCFGWRCFG	131
#define hkwd_LVM_OUT_CNCFGWRCFG	132
#define hkwd_LVM_IN_CNCBADRCV	133
#define hkwd_LVM_OUT_CNCBADRCV	134
#define hkwd_LVM_LOCKPART	135
#define hkwd_LVM_IN_KADDLV      136
#define hkwd_LVM_OUT_KADDLV     137
#define hkwd_LVM_IN_KCHGLV      138
#define hkwd_LVM_OUT_KCHGLV     139
#define hkwd_LVM_IN_KCHKLV      140
#define hkwd_LVM_OUT_KCHKLV     141
#define hkwd_LVM_IN_KEXTEND     142
#define hkwd_LVM_OUT_KEXTEND    143
#define hkwd_LVM_IN_GSEXTEND    144
#define hkwd_LVM_OUT_GSEXTEND   145
#define hkwd_LVM_IN_KREDUCE     146
#define hkwd_LVM_OUT_KREDUCE    147
#define hkwd_LVM_IN_GSREDUCE    148
#define hkwd_LVM_OUT_GSREDUCE   149
#define hkwd_LVM_IN_KMARKLV     150
#define hkwd_LVM_OUT_KMARKLV    151
#define hkwd_LVM_IN_KDELLV      152
#define hkwd_LVM_OUT_KDELLV     153
#define hkwd_LVM_IN_KADDMPV     154
#define hkwd_LVM_OUT_KADDMPV    155
#define hkwd_LVM_IN_KADDPV      156
#define hkwd_LVM_OUT_KADDPV     157
#define hkwd_LVM_IN_KCOPYBB     158
#define hkwd_LVM_OUT_KCOPYBB    159
#define hkwd_LVM_IN_KDELPV      160
#define hkwd_LVM_OUT_KDELPV     161
#define hkwd_LVM_IN_KCHGVGSA    162
#define hkwd_LVM_OUT_KCHGVGSA   163
#define hkwd_LVM_IN_CONFIG      164
#define hkwd_LVM_OUT_CONFIG     165
#define hkwd_LVM_IN_LVMCONFIG   166
#define hkwd_LVM_OUT_LVMCONFIG  167
#define hkwd_LVM_IN_VERIFYVGID  168
#define hkwd_LVM_OUT_VERIFYVGID 169
#define hkwd_LVM_IN_KDEFLVS     170
#define hkwd_LVM_OUT_KDEFLVS    171
#define hkwd_LVM_IN_KSETUPVG    172
#define hkwd_LVM_OUT_KSETUPVG   173
#define hkwd_LVM_IN_MWC_FPREC   174
#define hkwd_LVM_OUT_MWC_FPREC  175
#define hkwd_LVM_IN_KDEFVG      176
#define hkwd_LVM_OUT_KDEFVG     177
#define hkwd_LVM_IN_KDELVG      178
#define hkwd_LVM_OUT_KDELVG     179
#define hkwd_LVM_IN_FREE_LVOLS  180
#define hkwd_LVM_OUT_FREE_LVOLS 181
#define hkwd_LVM_IN_KCHGQRM     182
#define hkwd_LVM_OUT_KCHGQRM    183
#define hkwd_LVM_IN_KQRYVGS     184
#define hkwd_LVM_OUT_KQRYVGS    185
#define hkwd_LVM_IN_KREBUILD    186
#define hkwd_LVM_OUT_KREBUILD   187
#define hkwd_LVM_IN_KVGSTAT     188
#define hkwd_LVM_OUT_KVGSTAT    189
#define hkwd_LVM_IN_CFG         190
#define hkwd_LVM_OUT_CFG        191
#define hkwd_LVM_IN_CON1016     192
#define hkwd_LVM_OUT_CON1016    193
#define hkwd_LVM_IN_EXT_DALV    194
#define hkwd_LVM_OUT_EXT_DALV   195
#define hkwd_LVM_IN_CLVSWOVR    196
#define hkwd_LVM_OUT_CLVSWOVR   197
#define hkwd_LVM_IN_HDBEGIN	198
#define hkwd_LVM_IN_HDRESUME	199
#define hkwd_LVM_IN_HDSTART	200
#define hkwd_LVM_IN_STRATEGY	201

/* LVM non-I/O hook ID */
#define HKWDD_LVM_NONIO           0x39300000

/* LVM non-I/O subhooks */
#define hkwd_LVM_CFG_CMD        1   /* LVM config cmd */
#define hkwd_LVM_CONC_DIST_CMD  2   /* distributed cmd */
#define hkwd_LVM_CONC_DCFG_CH   3   /* dev, msg_type, result */
#define hkwd_LVM_CONC_EVENT     4   /* dev, event, line */
#define hkwd_LVM_CONC_TS        5   /* dev, tv_sec, tv_nsec, line */
#define hkwd_LVM_CONC_VGSA_CH   6   /* dev, msg_type, result */
#define hkwd_LVM_ERR_BBDIR      7   /* dev, flags, errno, line */
#define hkwd_LVM_ERR_CFGLV      8   /* dev, flags, errno, line */
#define hkwd_LVM_ERR_CFGPV      9   /* dev, flags, errno, line */
#define hkwd_LVM_ERR_CFGVG      10  /* dev, flags, errno, line */
#define hkwd_LVM_ERR_CONC       11  /* dev, flags, errno, line */
#define hkwd_LVM_ERR_GS_CONC    12  /* dev, flags, errno, line */
#define hkwd_LVM_ERR_SCHED      13  /* dev, flags, errno, line */
#define hkwd_LVM_ERR_STRAT      14  /* dev, flags, errno, line */
#define hkwd_LVM_ERR_TOP        15  /* dev, flags, errno, line */
#define hkwd_LVM_ERR_VGSA       16  /* dev, flags, errno, line */
#define hkwd_LVM_ERR_GSCLVMD    17  /* dev, flags, errno, line */
#define hkwd_LVM_EVENT          18  /* dev, event, line */
#define hkwd_LVM_SA_STRT        19  /* Put SA request on hold list */
#define hkwd_LVM_SA_CONT        20  /* continue writing VGSAs         */
#define hkwd_LVM_SA_WRT         21  /* split buf for next SA on wheel */
#define hkwd_LVM_SA_IODONE      22  /* iodone for VGSA write          */
#define hkwd_LVM_VGSA_DIO       23  /* vgsa parallel writes start     */
#define hkwd_LVM_VGSA_DIO_END   24  /* vgdsa parallel writes done     */
#define hkwd_LVM_SA_WHLADV      25  /* return vgsa done requestsr     */



#define HKWD_SYSC                 0x12000000
#define HKWD_SYSC_ACCESS          0x12000000
#define HKWD_SYSC_ACCT            0x12100000
#define HKWD_SYSC_ALARM           0x12200000
#define HKWD_SYSC_AUDIT           0x12300000
#define HKWD_SYSC_AUDITLOG        0x12400000
#define HKWD_SYSC_AUDITPROC       0x12500000
#define HKWD_SYSC_AUDITSYS        0x12600000
#define HKWD_SYSC_CHDIR           0x12700000
#define HKWD_SYSC_CHMAC           0x12800000
#define HKWD_SYSC_CHMOD           0x12900000
#define HKWD_SYSC_CHOWN           0x12a00000
#define HKWD_SYSC_CHOWNX          0x12b00000
#define HKWD_SYSC_CHPRIV          0x12c00000
#define HKWD_SYSC_CHROOT          0x12d00000
#define HKWD_SYSC_CLOSE           0x12e00000
#define HKWD_SYSC_CLOSEX          0x12f00000
#define HKWD_SYSC_CREAT           0x13000000
#define HKWD_SYSC_DISCLAIM        0x13100000
#define HKWD_SYSC_DUP             0x13300000
#define HKWD_SYSC_EXECVE          0x13400000
#define HKWD_SYSC__EXIT           0x13500000
#define HKWD_SYSC_FCLEAR          0x13600000
#define HKWD_SYSC_FCNTL           0x13700000
#define HKWD_SYSC_FFULLSTAT       0x13800000
#define HKWD_SYSC_FORK            0x13900000
#define HKWD_SYSC_FSTAT           0x13a00000
#define HKWD_SYSC_FSTATFS         0x13b00000
#define HKWD_SYSC_FSYNC           0x13c00000
#define HKWD_SYSC_FTRUNCATE       0x13d00000
#define HKWD_SYSC_FULLSTAT        0x13e00000
#define HKWD_SYSC_GETEGID         0x13f00000
#define HKWD_SYSC_GETEPRIV        0x14000000
#define HKWD_SYSC_GETEUID         0x14100000
#define HKWD_SYSC_GETGID          0x14200000
#define HKWD_SYSC_GETGROUPS       0x14300000
#define HKWD_SYSC_GETMPRIV        0x14400000
#define HKWD_SYSC_GETPGRP         0x14500000
#define HKWD_SYSC_GETPID          0x14600000
#define HKWD_SYSC_GETPPID         0x14700000
#define HKWD_SYSC_GETPRIV         0x14800000
#define HKWD_SYSC_GETTSTATE       0x14900000
#define HKWD_SYSC_GETUID          0x14a00000
#define HKWD_SYSC_GTTY            0x14b00000
#define HKWD_SYSC_IOCTL           0x14c00000
#define HKWD_SYSC_IOCTLX          0x14d00000
#define HKWD_SYSC_KILL            0x14e00000
#define HKWD_SYSC_KPRINTF         0x14f00000
#define HKWD_SYSC_LINK            0x15000000
#define HKWD_SYSC_LOADTBL         0x15100000
#define HKWD_SYSC_LOCKF           0x15200000
#define HKWD_SYSC_LOCKX           0x15300000
#define HKWD_SYSC_LSEEK           0x15400000
#define HKWD_SYSC_MACCTL          0x15500000
#define HKWD_SYSC_MKDIR           0x15600000
#define HKWD_SYSC_MKNOD           0x15700000
#define HKWD_SYSC_MNTCTL          0x15800000
#define HKWD_SYSC_MOUNT           0x15900000
#define HKWD_SYSC_NICE            0x15a00000
#define HKWD_SYSC_OPEN            0x15b00000
#define HKWD_SYSC_OPENX           0x15c00000
#define HKWD_SYSC_OUNAME          0x15d00000
#define HKWD_SYSC_PAUSE           0x15e00000
#define HKWD_SYSC_PIPE            0x15f00000
#define HKWD_SYSC_PLOCK           0x16000000
#define HKWD_SYSC_PROFIL          0x16100000
#define HKWD_SYSC_PTRACE          0x16200000
#define HKWD_SYSC_READ            0x16300000
#define HKWD_SYSC_READLINK        0x16400000
#define HKWD_SYSC_READX           0x16500000
#define HKWD_SYSC_REBOOT          0x16600000
#define HKWD_SYSC_RENAME          0x16700000
#define HKWD_SYSC_RMDIR           0x16800000
#define HKWD_SYSC_SBREAK          0x16900000
#define HKWD_SYSC_SELECT          0x16a00000
#define HKWD_SYSC_SETGID          0x16b00000
#define HKWD_SYSC_SETGROUPS       0x16c00000
#define HKWD_SYSC_SETMAC          0x16d00000
#define HKWD_SYSC_SETPGRP         0x16e00000
#define HKWD_SYSC_SETPRIO         0x16f00000
#define HKWD_SYSC_SETPRIV         0x17000000
#define HKWD_SYSC_SETREUID        0x17100000
#define HKWD_SYSC_SETTSTATE       0x17200000
#define HKWD_SYSC_SETUID          0x17300000
#define HKWD_SYSC_SIGACTION       0x18000000
#define HKWD_SYSC_SIGCLEANUP      0x18100000
#define HKWD_SYSC_SIGPROCMASK     0x18200000
#define HKWD_SYSC_SIGRETURN       0x18300000
#define HKWD_SYSC_SIGSTACK        0x18400000
#define HKWD_SYSC_SIGSUSPEND      0x18500000
#define HKWD_SYSC_STAT            0x18600000
#define HKWD_SYSC_STATFS          0x18700000
#define HKWD_SYSC_STATX           0x18800000
#define HKWD_SYSC_STIME           0x18900000
#define HKWD_SYSC_STTY            0x18a00000
#define HKWD_SYSC_SYMLINK         0x18b00000
#define HKWD_SYSC_SYNC            0x18c00000
#define HKWD_SYSC_TIME            0x18d00000
#define HKWD_SYSC_TIMES           0x18e00000
#define HKWD_SYSC_ULIMIT          0x18f00000
#define HKWD_SYSC_UMASK           0x19000000
#define HKWD_SYSC_UMOUNT          0x19100000
#define HKWD_SYSC_UNAME           0x19200000
#define HKWD_SYSC_UNAMEX          0x19300000
#define HKWD_SYSC_UNLINK          0x19400000
#define HKWD_SYSC_USRINFO         0x19500000
#define HKWD_SYSC_USTAT           0x19600000
#define HKWD_SYSC_UTIME           0x19700000
#define HKWD_SYSC_UTSSYS          0x19800000
#define HKWD_SYSC_UVMOUNT         0x19900000
#define HKWD_SYSC_VMOUNT          0x19a00000
#define HKWD_SYSC_WAIT            0x19b00000
#define HKWD_SYSC_WRITE           0x19c00000
#define HKWD_SYSC_WRITEX          0x19d00000
#define HKWD_SYSC_FCHMOD          0x19e00000
#define HKWD_SYSC_FCHOWN          0x19f00000
#define HKWD_SYSC_GETDIRENTRIES   0x1a000000
#define HKWD_SYSC_LSTAT           0x1a100000
#define HKWD_SYSC_UTIMES          0x1a200000
#define HKWD_SYSC_SLOOKUP         0x1a300000
#define HKWD_SYSC_GETRLIMIT       0x1a400000
#define HKWD_SYSC_SETRLIMIT       0x1a500000
#define HKWD_SYSC_GETRUSAGE       0x1a600000
#define HKWD_SYSC_GETPRIORITY     0x1a700000
#define HKWD_SYSC_SETPRIORITY     0x1a800000
#define HKWD_SYSC_ABSINTERVAL     0x1a900000
#define HKWD_SYSC_GETINTERVAL     0x1aa00000
#define HKWD_SYSC_GETTIMER        0x1ab00000
#define HKWD_SYSC_INCINTERVAL     0x1ac00000
#define HKWD_SYSC_RESTIMER        0x1ad00000
#define HKWD_SYSC_RESABS          0x1ae00000
#define HKWD_SYSC_RESINC          0x1af00000
#define HKWD_SYSC_SETTIMER        0x1f000000
#define HKWD_SYSC_GETARGS         0x1f100000
#define HKWD_SYSC_GETPROC         0x1f200000
#define HKWD_SYSC_GETUSER         0x1f300000
#define HKWD_SYSC_KNLIST          0x1f400000
#define HKWD_SYSC_SETSID          0x1f500000
#define HKWD_SYSC_SETPGID         0x1f600000
#define HKWD_SYSC_SETREGID        0x1f700000
#define HKWD_SYSC_SETPRI          0x1f800000

#define HKWD_VMM                  0x1b000000
#define HKWD_VMM_ASSIGN           0x1b000000
#define HKWD_VMM_DELETE           0x1b100000
#define HKWD_VMM_PGEXCT           0x1b200000
#define HKWD_VMM_PROTEXCT         0x1b300000
#define HKWD_VMM_LOCKEXCT         0x1b400000
#define HKWD_VMM_RECLAIM          0x1b500000
#define HKWD_VMM_PINGPONG         0x1b500001
#define HKWD_VMM_GETPARENT        0x1b600000
#define HKWD_VMM_COPYPARENT       0x1b700000
#define HKWD_VMM_MAPPARENT        0x1b700001
#define HKWD_VMM_COWRELOAD        0x1b700002
#define HKWD_VMM_VMAP             0x1b800000
#define HKWD_VMM_ZFOD             0x1b900000
#define HKWD_VMM_SIO              0x1ba00000
#define HKWD_VMM_PAGEOUT          0x1ba00000
#define HKWD_VMM_PAGEIN           0x1ba00001
#define HKWD_VMM_SEGCREATE        0x1bb00000
#define HKWD_VMM_SEGDELETE        0x1bc00000
#define HKWD_VMM_DALLOC           0x1bd00000
#define HKWD_VMM_PFENDOUT         0x1be00000
#define HKWD_VMM_PFENDIN          0x1be00001
#define HKWD_VMM_EXCEPT           0x1bf00000
#define HKWD_VMM_ZERO_0		  0x1d900000
#define HKWD_VMM_ZERO_1		  0x1d900001
#define HKWD_VMM_MKP		  0x1da00000
#define HKWD_VMM_FPGIN		  0x1db00000
#define HKWD_VMM_SPACEOK_0        0x1dc00000
#define HKWD_VMM_SPACEOK_1        0x1dc00001
#define HKWD_VMM_LRU_0            0x1dd00000
#define HKWD_VMM_LRU_1            0x1dd00001
#define HKWD_VMM_LRU_2            0x1dd00002
#define HKWD_VMM_LRU_3            0x1dd00003
#define HKWD_VMM_LRU_4            0x1dd00004
#define HKWD_VMM_LRU_5            0x1dd00005
#define HKWD_VMM_LRU_6            0x1dd00006
#define HKWD_VMM_LRU_7            0x1dd00007
#define HKWD_VMM_LRU_8            0x1dd00008
#define HKWD_VMM_LRU_9            0x1dd00009
#define HKWD_VMM_LRU_A            0x1dd0000a
#define HKWD_VMM_VWAIT            0x2FC00000

/* System V IPC Trace Hooks */
#define HKWD_SYSC_IPCACCESS       0x3c500000
#define HKWD_SYSC_IPCGET          0x3c600000

/* System V Message Queue Trace Hooks */
#define HKWD_SYSC_MSGCONV         0x3c700000
#define HKWD_SYSC_MSGCTL          0x3c800000
#define HKWD_SYSC_MSGGET          0x3c900000
#define HKWD_SYSC_MSGRCV          0x3ca00000
#define HKWD_SYSC_MSGSELECT       0x3cb00000
#define HKWD_SYSC_MSGSND          0x3cc00000
#define HKWD_SYSC_MSGXRCV         0x3cd00000

/* System V Semaphore Sets Trace Hooks */
#define HKWD_SYSC_SEMCONV         0x3ce00000
#define HKWD_SYSC_SEMCTL          0x3cf00000
#define HKWD_SYSC_SEMGET          0x3d000000
#define HKWD_SYSC_SEMOP           0x3d100000
#define HKWD_SYSC_SEM_OP          0x3d200000

/* System V Shared Memory Region Trace Hooks */
#define HKWD_SYSC_SHMAT           0x3d300000
#define HKWD_SYSC_SHMCONV         0x3d400000
#define HKWD_SYSC_SHMCTL          0x3d500000
#define HKWD_SYSC_SHMDT           0x3d600000
#define HKWD_SYSC_SHMGET          0x3d700000

/* mmap Services Trace Hooks */
#define HKWD_SYSC_MADVISE         0x3d800000
#define HKWD_SYSC_MINCORE         0x3d900000
#define HKWD_SYSC_MMAP            0x3da00000
#define HKWD_SYSC_MPROTECT        0x3db00000
#define HKWD_SYSC_MSYNC           0x3dc00000
#define HKWD_SYSC_MUNMAP          0x3dd00000
#define HKWD_SYSC_MVALID          0x3de00000

/* msemaphore Services Trace Hooks */
#define HKWD_SYSC_MSEM_INIT       0x3df00000
#define HKWD_SYSC_MSEM_LOCK       0x3e000000
#define HKWD_SYSC_MSEM_REMOVE     0x3e100000
#define HKWD_SYSC_MSEM_UNLOCK     0x3e200000

#define HKWD_DD                   0x1c000000
#define HKWD_DD_STRATEGY          0x1c000000
#define HKWD_DD_START             0x1c100000
#define HKWD_DD_INTR              0x1c200000
#define HKWD_DD_GETBLK            0x1c300000
#define HKWD_DD_IOWAIT            0x1c400000
#define HKWD_DD_IODONE            0x1c500000
#define HKWD_DD_PHYSIO            0x1c600000
#define HKWD_DD_ATTACH            0x1c700000
#define HKWD_DD_PPDD              0x1c800000    /* parallel printer DD */
#define HKWD_DD_CDDD              0x1c900000    /* cdrom DD */
#define HKWD_DD_TAPEDD            0x1ca00000    /* tape DD */
#define HKWD_DD_CIODD             0x1cb00000    /* cio DD */
#define HKWD_DD_ETHDD             0x1cc00000    /* cio PC  ethernet DD */
#define HKWD_DD_ENTDD             0x1cd00000    /* cio MCA ethernet DD */
#define HKWD_DD_TOKDD             0x1ce00000    /* cio MCA tokenring DD */
#define HKWD_DD_C327DD            0x1cf00000    /* 3270 DD */

#define HKWD_DD_FDDD              0x22000000    /* diskette DD */
#define HKWD_DD_SCDISKDD          0x22100000    /* SCSI Disk DD */
#define HKWD_DD_BADISKDD          0x22200000    /* Bus Attached Disk DD */
#define HKWD_DD_SCSIDD            0x22300000    /* SCSI Adapter DD    */
#define HKWD_DD_MPQPDD            0x22400000    /* multi-protocol     */
#define HKWD_DD_X25DD             0x22500000    /* X.25 Device Driver */
#define HKWD_DD_GIO               0x22600000    /* G.I. Joe */
#define HKWD_DD_X25PRF            0x22700000    /* X.25 performance  */
#define HKWD_DD_SERDASDD          0x22800000    /* Serial DASD Subsystem */
#define HKWD_DD_TMSCSIDD          0x22900000    /* SCSI Target Mode DD */
#define	HKWD_DD_SOL		  0x24800000	/* optic 2-port */
#define HKWD_DD_CATDD             0x35000000    /* S/370 Channel */
#define HKWD_DD_SISADD            0x38E00000    /* SIS based SCSI DD */
#define HKWD_DD_SISRAID           0x39000000    /* SIS based SCSI (RAID) DD */
#define HKWD_USBCDROM		  0x47c00000	/* USB CD-ROM client driver */


#define HKWD_DDSPEC               0x1d000000
#define HKWD_DDSPEC_GRAPHIO       0x1d000000
#define HKWD_RAS_ERRLG            0x1d100000
#define HKWD_RAS_DUMP             0x1d200000

#define HKWD_LPP_PCSIM            0x1d300000
#define hkwd_PCSIM_FILE   1
#define hkwd_PCSIM_DISP   2
#define hkwd_PCSIM_CNTL   3
#define hkwd_PCSIM_PCAT   4
#define hkwd_PCSIM_DSKT   5

#define HKWD_WHIP_API             0x1d400000
#define HKWD_WHIP_DAEMON          0x1d500000
#define HKWD_WHIP_DRIVER          0x1d600000
#define HKWD_WHIP_EMUL            0x1d700000
#define HKWD_WHIP_FILE            0x1d800000

#define HKWD_COMM                 0x1e000000
#define HKWD_COMM_EM78            0x1e000000

/*
 * Socket, Network, and Network Interface hook id and sub-hook id's
 */

#define HKWD_NETPERF		0x25000000

#define HKWD_NETERR		0x25100000 

#define HKWD_SOCKET		0x25200000
#define hkwd_accept_in			1
#define hkwd_accept_out			2
#define hkwd_bind_in			3
#define hkwd_bind_out			4
#define hkwd_connect_in			5
#define hkwd_connect_out		6
#define hkwd_getkerninfo_in		7
#define hkwd_getkerninfo_out		8
#define hkwd_getpeername_in		9
#define hkwd_getpeername_out		10
#define hkwd_getsockname_in		11
#define hkwd_getsockname_out		12
#define hkwd_getsockopt_in		13
#define hkwd_getsockopt_out		14
#define hkwd_listen_in			15
#define hkwd_listen_out			16
#define hkwd_recv_in			17
#define hkwd_recv_out			18
#define hkwd_recvfrom_in		19
#define hkwd_recvfrom_out		20
#define hkwd_recvit_in			21
#define hkwd_recvit_out			22
#define hkwd_recvmsg_err		23
#define hkwd_recvmsg_in			24
#define hkwd_recvmsg_out		25
#define hkwd_rmsock_in			26
#define hkwd_rmsock_out			27
#define hkwd_sbwakeup_in		28
#define hkwd_sbwakeup_out		29
#define hkwd_send_in			30
#define hkwd_send_out			31
#define hkwd_sendfile_in		32
#define hkwd_sendfile_out		33
#define hkwd_sendit_in			34
#define hkwd_sendit_out			35
#define hkwd_sendmsg_in			36
#define hkwd_sendmsg_out		37
#define hkwd_sendto_in			38
#define hkwd_setsockopt_in		39
#define hkwd_setsockopt_out		40
#define hkwd_shutdown_in		41
#define hkwd_shutdown_out		42
#define hkwd_soabort_in			43
#define hkwd_soabort_out		44
#define hkwd_soaccept_in		45
#define hkwd_soaccept_out		46
#define hkwd_soaccessfailure_in		47
#define hkwd_soaccessfailure_out	48
#define hkwd_sobind_in			49
#define hkwd_sobind_out			50
#define hkwd_sockargs_in		51
#define hkwd_sockargs_out		52
#define hkwd_socket_aio_dequeue_in	53
#define hkwd_socket_aio_dequeue_out	54
#define hkwd_socket_in			55
#define hkwd_socket_out			56
#define hkwd_socketpair_err		57
#define hkwd_socketpair_in		58
#define hkwd_socketpair_out		59
#define hkwd_socksetup_in		60
#define hkwd_socksetup_out		61
#define hkwd_soclose_in			62
#define hkwd_soclose_out		63
#define hkwd_soconnect2_in		64
#define hkwd_soconnect2_out		65
#define hkwd_soconnect_in		66
#define hkwd_soconnect_out		67
#define hkwd_socreate_err		68
#define hkwd_socreate_in		69
#define hkwd_socreate_out		70
#define hkwd_socreategroup_err		71
#define hkwd_socreategroup_in		72
#define hkwd_socreategroup_out		73
#define hkwd_sodisconn_in		74
#define hkwd_sodisconn_out		75
#define hkwd_sodisconnect_in		76
#define hkwd_sodisconnect_out		77
#define hkwd_sofree_err			78
#define hkwd_sofree_in			79
#define hkwd_sofree_out			80
#define hkwd_sogetopt_in		81
#define hkwd_sogetopt_out		82
#define hkwd_sohasoutofband_in		83
#define hkwd_sohasoutofband_out		84
#define hkwd_soisconnected_in		85
#define hkwd_soisconnected_out		86
#define hkwd_soisdisconnected_in	87
#define hkwd_soisdisconnected_out	88
#define hkwd_solisten_in		89
#define hkwd_solisten_out		90
#define hkwd_sonewsock_in		91
#define hkwd_sonewsock_out		92
#define hkwd_soo_close_in		93
#define hkwd_soo_close_out		94
#define hkwd_soo_ioctl_in		95
#define hkwd_soo_ioctl_out		96
#define hkwd_soo_read_in		97
#define hkwd_soo_read_out		98
#define hkwd_soo_select_in		99
#define hkwd_soo_select_out		100
#define hkwd_soo_stat_in		101
#define hkwd_soo_stat_out		102
#define hkwd_soo_write_in		103
#define hkwd_soo_write_out		104
#define hkwd_soreceive_in		105
#define hkwd_soreceive_out		106
#define hkwd_soreserve_in		107
#define hkwd_soreserve_out		108
#define hkwd_sorflush_in		109
#define hkwd_sorflush_out		110
#define hkwd_sosbwait_in		111
#define hkwd_sosbwait_out		112
#define hkwd_sosend_in			113
#define hkwd_sosend_out			114
#define hkwd_sosetopt_in		115
#define hkwd_sosetopt_out		116
#define hkwd_soshutdown_in		117
#define hkwd_soshutdown_out		118
#define hkwd_sosleep_in			119
#define hkwd_sosleep_out		120
#define hkwd_sosplice_in		121
#define hkwd_sosplice_out		122
#define hkwd_sowakeup_in		123
#define hkwd_sowakeup_out		124
#define hkwd_splice_in			125
#define hkwd_splice_out			126
#define hkwd_gethostid_in		127
#define hkwd_sethostid_in		128
#define hkwd_gethostname_in		129
#define hkwd_sethostname_in		130
#define hkwd_getdomainname_in		131
#define hkwd_setdomainname_in		132
#define hkwd_getdomainname_out		133
#define hkwd_getpeereid_in              134
#define hkwd_getpeereid_out             135


#define HKWD_TCP			0x53500000
#define hkwd_isprivport_in			1
#define hkwd_reroute_in				2
#define hkwd_splice_forward_in			3
#define hkwd_splice_forward_out			4
#define hkwd_tcp_SACKFastRecovery_in		5
#define hkwd_tcp_UpSACKInfo_in			6
#define hkwd_tcp_UpSACKInfo_out			7
#define hkwd_tcp_achalloc_in			8
#define hkwd_tcp_achfree_in			9
#define hkwd_tcp_achref_out			10
#define hkwd_tcp_achset_out			11
#define hkwd_tcp_acladd_in			12
#define hkwd_tcp_acladd_out			13
#define hkwd_tcp_aclbind_in			14
#define hkwd_tcp_aclclear_nolock_in		15
#define hkwd_tcp_acldel_in			16
#define hkwd_tcp_acldel_out			17
#define hkwd_tcp_aclflush_in			18
#define hkwd_tcp_aclls_in			19
#define hkwd_tcp_aclls_out			20
#define hkwd_tcp_adjust_buffers_in		21
#define hkwd_tcp_adjust_buffers_out		22
#define hkwd_tcp_attach_in			23
#define hkwd_tcp_attach_out			24
#define hkwd_tcp_auth0_in			25
#define hkwd_tcp_auth0_out1			26
#define hkwd_tcp_auth0_out2			27
#define hkwd_tcp_auth_in			28
#define hkwd_tcp_auth_out1			29
#define hkwd_tcp_auth_out2			30
#define hkwd_tcp_build_sacks_err		31
#define hkwd_tcp_build_sacks_in			32
#define hkwd_tcp_build_sacks_out		33
#define hkwd_tcp_canceltimers			34
#define hkwd_tcp_close_in			35
#define hkwd_tcp_close_out			36
#define hkwd_tcp_ctlinput_in			37
#define hkwd_tcp_ctlinput_out			38
#define hkwd_tcp_ctloutput_in			39
#define hkwd_tcp_ctloutput_out			40
#define hkwd_tcp_delayack_set_in		41
#define hkwd_tcp_delayack_set_out		42
#define hkwd_tcp_disconnect_in			43
#define hkwd_tcp_disconnect_out			44
#define hkwd_tcp_dooptions_in			45
#define hkwd_tcp_dooptions_out			46
#define hkwd_tcp_drop_in			47
#define hkwd_tcp_ephemeral_high_change_in	48
#define hkwd_tcp_ephemeral_high_change_out	49
#define hkwd_tcp_ephemeral_low_change_in	50
#define hkwd_tcp_ephemeral_low_change_out	51
#define hkwd_tcp_fasttimo_in			52
#define hkwd_tcp_fasttimo_out			53
#define hkwd_tcp_init_in			54
#define hkwd_tcp_init_out			55
#define hkwd_tcp_input0_in			56
#define hkwd_tcp_input0_out1			57
#define hkwd_tcp_input0_out2			58
#define hkwd_tcp_input0_out3			59
#define hkwd_tcp_input0_out4			60
#define hkwd_tcp_input0_out5			61
#define hkwd_tcp_input0_out6			62
#define hkwd_tcp_input0_out7			63
#define hkwd_tcp_input0_out8			64
#define hkwd_tcp_input0_out9			65
#define hkwd_tcp_input_in			66
#define hkwd_tcp_input_out			67
#define hkwd_tcp_lspriv_in			68
#define hkwd_tcp_lspriv_out			69
#define hkwd_tcp_map_pseg_in			70
#define hkwd_tcp_map_pseg_out			71
#define hkwd_tcp_mss_in				72
#define hkwd_tcp_mss_out			73
#define hkwd_tcp_newtcpcb_in			74
#define hkwd_tcp_newtcpcb_out			75
#define hkwd_tcp_notify_in			76
#define hkwd_tcp_notify_out			77
#define hkwd_tcp_output_in			78
#define hkwd_tcp_output_out			79
#define hkwd_tcp_pmtuchange_in			80
#define hkwd_tcp_process_sackopt_in		81
#define hkwd_tcp_process_sackopt_out1		82
#define hkwd_tcp_process_sackopt_out2		83
#define hkwd_tcp_pulloutofband_in		84
#define hkwd_tcp_pulloutofband_out		85
#define hkwd_tcp_quench_in			86
#define hkwd_tcp_reass_in			87
#define hkwd_tcp_reass_out1			88
#define hkwd_tcp_reass_out2			89
#define hkwd_tcp_reass_out3			90
#define hkwd_tcp_reass_out4			91
#define hkwd_tcp_reass_out5			92
#define hkwd_tcp_resend_in			93
#define hkwd_tcp_resend_out			94
#define hkwd_tcp_resprst_err			95
#define hkwd_tcp_resprst_in			96
#define hkwd_tcp_resprst_out			97
#define hkwd_tcp_send_and_disconnect_err	98
#define hkwd_tcp_send_and_disconnect_in		99
#define hkwd_tcp_send_and_disconnect_out	100
#define hkwd_tcp_send_and_kern_disconnect_err	101
#define hkwd_tcp_send_and_kern_disconnect_in	102
#define hkwd_tcp_send_and_kern_disconnect_out	103
#define hkwd_tcp_sendkeep_err			104
#define hkwd_tcp_sendkeep_in			105
#define hkwd_tcp_sendkeep_out			106
#define hkwd_tcp_setmss_in			107
#define hkwd_tcp_setmss_out			108
#define hkwd_tcp_setpersist_in			109
#define hkwd_tcp_setpersist_out			110
#define hkwd_tcp_setpriv_in			111
#define hkwd_tcp_setpriv_out			112
#define hkwd_tcp_slowtimo_in			113
#define hkwd_tcp_slowtimo_out			114
#define hkwd_tcp_splice_in			115
#define hkwd_tcp_splice_out			116
#define hkwd_tcp_template_in			117
#define hkwd_tcp_time_wait_timer_in		118
#define hkwd_tcp_time_wait_timer_out		119
#define hkwd_tcp_timer_init_in			120
#define hkwd_tcp_timers_in			121
#define hkwd_tcp_timers_out			122
#define hkwd_tcp_unsetpriv_in			123
#define hkwd_tcp_unsetpriv_out			124
#define hkwd_tcp_update_sacks_in		125
#define hkwd_tcp_update_sacks_out		126
#define hkwd_tcp_usrclosed_in			127
#define hkwd_tcp_usrclosed_out			128
#define hkwd_tcp_usrreq_err			129
#define hkwd_tcp_usrreq_in			130
#define hkwd_tcp_usrreq_out			131
#define hkwd_tcp_xmit_timer_in			132
#define hkwd_tcp_xmit_timer_out			133

#define HKWD_UDP			0x53600000
#define hkwd_delay_sbdroprecord   		1
#define hkwd_udp_cksum_and_move_in   		2
#define hkwd_udp_cksum_and_move_out   		3
#define hkwd_udp_ctlinput_in   			4
#define hkwd_udp_ctlinput_out   		5
#define hkwd_udp_ephemeral_high_change_in   	6
#define hkwd_udp_ephemeral_low_change_in   	7
#define hkwd_udp_findmac_in   			8
#define hkwd_udp_findmac_out1   		9
#define hkwd_udp_findmac_out2   		10
#define hkwd_udp_init_in   			11
#define hkwd_udp_init_out   			12
#define hkwd_udp_input0_in   			13
#define hkwd_udp_input0_out1   			14
#define hkwd_udp_input0_out2   			15
#define hkwd_udp_input0_out3   			16
#define hkwd_udp_input0_out4   			17
#define hkwd_udp_input0_out5   			18
#define hkwd_udp_input1_in   			19
#define hkwd_udp_input1_out   			20
#define hkwd_udp_input_in   			21
#define hkwd_udp_input_out   			22
#define hkwd_udp_output_in   			23
#define hkwd_udp_output_out   			24
#define hkwd_udp_receive_in   			25
#define hkwd_udp_receive_out   			26
#define hkwd_udp_saveopt_in   			27
#define hkwd_udp_saveopt_out1   		28
#define hkwd_udp_saveopt_out2   		29
#define hkwd_udp_saveopt_out3   		30
#define hkwd_udp_saveopt_out4   		31
#define hkwd_udp_usrreq_in   			32
#define hkwd_udp_usrreq_out   			33
#define hkwd_udpsend_in   			34
#define hkwd_udpsend_out   			35


#define HKWD_IP			0x53700000
#define hkwd_add_mfc_in			1
#define hkwd_add_mfc_out		2
#define hkwd_add_vif_in			3
#define hkwd_add_vif_out		4
#define hkwd_del_mfc_in			5
#define hkwd_del_mfc_out		6
#define hkwd_del_vif_in			7
#define hkwd_del_vif_out		8
#define hkwd_dequeue_pfctlinput_in	9
#define hkwd_dequeue_pfctlinput_out	10
#define hkwd_doghash_in			11
#define hkwd_doghash_out1		12
#define hkwd_doghash_out2		13
#define hkwd_doginit_in			14
#define hkwd_doginit_out1		15
#define hkwd_doginit_out2		16
#define hkwd_doginit_out3		17
#define hkwd_doginit_out4		18
#define hkwd_dogisr_in			19
#define hkwd_dogisr_out			20
#define hkwd_dogproc_in			21
#define hkwd_dogproc_out		22
#define hkwd_dogthread_in		23
#define hkwd_dogthread_out		24
#define hkwd_encap_send_in		25
#define hkwd_encap_send_out		26
#define hkwd_expire_upcalls_in		27
#define hkwd_expire_upcalls_out		28
#define hkwd_get_sg_cnt_in		29
#define hkwd_get_sg_cnt_out		30
#define hkwd_get_vif_cnt_in		31
#define hkwd_get_vif_cnt_out		32
#define hkwd_gids_ok_in			33
#define hkwd_gids_ok_out		34
#define hkwd_icmp_error_in		35
#define hkwd_icmp_error_out		36
#define hkwd_icmp_input_in		37
#define hkwd_icmp_input_out		38
#define hkwd_icmp_reflect_in		39
#define hkwd_icmp_reflect_out		40
#define hkwd_icmp_send_in		41
#define hkwd_icmp_send_out		42
#define hkwd_in_flip_and_run_in		43
#define hkwd_in_flip_and_run_out	44
#define hkwd_inbound_fw_free_args_in	45
#define hkwd_inbound_fw_save_args_in	46
#define hkwd_inbound_fw_save_args_out	47
#define hkwd_ip_changeversion_in	48
#define hkwd_ip_changeversion_out	49
#define hkwd_ip_ctloutput_in		50
#define hkwd_ip_ctloutput_out		51
#define hkwd_ip_dootions_in		52
#define hkwd_ip_drain_in		53
#define hkwd_ip_flush_packet_in		54
#define hkwd_ip_flush_packet_out	55
#define hkwd_ip_forward_in		56
#define hkwd_ip_forward_out1		57
#define hkwd_ip_forward_out2		58
#define hkwd_ip_forward_out3		59
#define hkwd_ip_forward_out4		60
#define hkwd_ip_forward_out5		61
#define hkwd_ip_freef_in		62
#define hkwd_ip_freemoptions_in		63
#define hkwd_ip_freemoptions_out	64
#define hkwd_ip_getmoptions_in		65
#define hkwd_ip_getmoptions_out		66
#define hkwd_ip_init_in			67
#define hkwd_ip_init_out		68
#define hkwd_ip_initr_in		69
#define hkwd_ip_initr_out		70
#define hkwd_ip_insertoptions_in	71
#define hkwd_ip_insertoptions_out	72
#define hkwd_ip_mdq_in			73
#define hkwd_ip_mdq_out			74
#define hkwd_ip_mforward_in		75
#define hkwd_ip_mforward_out		76
#define hkwd_ip_mloopback_in		77
#define hkwd_ip_mloopback_out		78
#define hkwd_ip_mrouter_done_in		79
#define hkwd_ip_mrouter_done_out	80
#define hkwd_ip_mrouter_get_in		81
#define hkwd_ip_mrouter_init_in		82
#define hkwd_ip_mrouter_init_out	83
#define hkwd_ip_mrouter_set_in		84
#define hkwd_ip_output_in		85
#define hkwd_ip_output_post_fw_in	86
#define hkwd_ip_output_post_fw_out	87
#define hkwd_ip_pcbopts_in		88
#define hkwd_ip_pcbopts_out1		89
#define hkwd_ip_pcbopts_out2		90
#define hkwd_ip_pmtu_start_in		91
#define hkwd_ip_pmtu_start_out		92
#define hkwd_ip_pmtu_stopt_in		93
#define hkwd_ip_pmtu_stopt_out		94
#define hkwd_ip_pmtu_timeout_in		95
#define hkwd_ip_pmtu_timeout_out	96
#define hkwd_ip_reass_in		97
#define hkwd_ip_reass_out1		98
#define hkwd_ip_reass_out2		99
#define hkwd_ip_rsvp_force_done_in	100
#define hkwd_ip_rsvp_force_done_out	101
#define hkwd_ip_rsvp_vif_done_in	102
#define hkwd_ip_rsvp_vif_done_out	103
#define hkwd_ip_rsvp_vif_init_in	104
#define hkwd_ip_rsvp_vif_init_out	105
#define hkwd_ip_rtaddr_in		106
#define hkwd_ip_rtaddr_out		107
#define hkwd_ip_setdupmtu_in		108
#define hkwd_ip_setdupmtu_out		109
#define hkwd_ip_setmoptions_in		110
#define hkwd_ip_setmoptions_out		111
#define hkwd_ip_slowtimo_in		112
#define hkwd_ip_srcroute_in		113
#define hkwd_ip_srcroute_out		114
#define hkwd_ip_stripoptions_in		115
#define hkwd_ip_stripoptions_out	116
#define hkwd_ipintr_noqueue_in		117
#define hkwd_ipintr_noqueue_out		118
#define hkwd_ipintr_noqueue_post_fw_in	119
#define hkwd_ipintr_noqueue_post_fw_out	120
#define hkwd_ipip_input_in		121
#define hkwd_ipip_input_out		122
#define hkwd_localaddr_notcast_in	123
#define hkwd_localaddr_notcast_out	124
#define hkwd_mroute_init_in		125
#define hkwd_mrt_ioctl_in		126
#define hkwd_outbound_fw_free_args_in	127
#define hkwd_outbound_fw_free_args_out	128
#define hkwd_outbound_fw_save_args_in	129
#define hkwd_outbound_fw_save_args_out	130
#define hkwd_phyint_send_in		131
#define hkwd_phyint_send_out		132
#define hkwd_pmtu_default_age_init_in	133
#define hkwd_pmtu_default_age_upd_in	134
#define hkwd_pmtu_default_age_upd_out	135
#define hkwd_pmtu_redis_intrvl_init_in	136
#define hkwd_pmtu_rtrequest_in		137
#define hkwd_pmtu_rtrequest_out		138
#define hkwd_priority_in		139
#define hkwd_priority_out		140
#define hkwd_queue_pfctlinput_in	141
#define hkwd_queue_pfctlinput_out	142
#define hkwd_raw_saveif_in		143
#define hkwd_raw_saveif_out		144
#define hkwd_rip_ctloutput_in		145
#define hkwd_rip_ctloutput_out		146
#define hkwd_rip_init_in		147
#define hkwd_rip_init_out		148
#define hkwd_rip_input_in		149
#define hkwd_rip_output_in		150
#define hkwd_rip_output_out		151
#define hkwd_rip_usrreq_in		152
#define hkwd_rip_usrreq_out		153
#define hkwd_rsvp_input_in		154
#define hkwd_rsvp_input_out		155
#define hkwd_save_rte_in		156
#define hkwd_save_rte_out		157
#define hkwd_socket_send_in		158
#define hkwd_socket_send_out		159
#define hkwd_tbf_control_in		160
#define hkwd_tbf_control_out		161
#define hkwd_tbf_dq_sel_in		162
#define hkwd_tbf_dq_sel_out		163
#define hkwd_tbf_process_q_in		164
#define hkwd_tbf_process_q_out		165
#define hkwd_tbf_reprocess_q_in		166
#define hkwd_tbf_reprocess_q_out	167
#define hkwd_tbf_send_packet_in		168
#define hkwd_tbf_send_packet_out	169
#define hkwd_tcp_pmtu_discover_init_in	170
#define hkwd_tcp_pmtu_discover_init_out	171
#define hkwd_tcp_pmtu_discover_upd_in	172
#define hkwd_tcp_pmtu_discover_upd_out	173
#define hkwd_udp_pmtu_discover_init_in	174
#define hkwd_udp_pmtu_discover_init_out	175
#define hkwd_udp_pmtu_discover_upd_in	176
#define hkwd_udp_pmtu_discover_upd_out	177

#define HKWD_IP6			0x53800000
#define hkwd_dopt6_input_in			1
#define hkwd_dopt6_input_out			2
#define hkwd_end6_input_in			3
#define hkwd_frg6_drain				4
#define hkwd_frg6_freef_in			5
#define hkwd_frg6_input_in			6
#define hkwd_frg6_input_out			7
#define hkwd_frg6_slowtimo_in			8
#define hkwd_hd6_inoptions_in			9
#define hkwd_hd6_inoptions_out			10
#define hkwd_hd6_outoptions			11
#define hkwd_hop6_input_in			12
#define hkwd_hop6_input_out			13
#define hkwd_icmp6_error_in			14
#define hkwd_icmp6_error_out1			15
#define hkwd_icmp6_error_out2			16
#define hkwd_icmp6_errparam_in			17
#define hkwd_icmp6_fasttimo_in			18
#define hkwd_icmp6_init_in			19
#define hkwd_icmp6_input_in			20
#define hkwd_icmp6_input_out			21
#define hkwd_icmp6_joingroup			22
#define hkwd_icmp6_leavegroup			23
#define hkwd_icmp6_reflect_in			24
#define hkwd_icmp6_reflect_out			25
#define hkwd_icmp6_send_in			26
#define hkwd_icmp6_send_out			27
#define hkwd_icmp6_sendmld_in			28
#define hkwd_icmp6_sendmld_out1			29
#define hkwd_icmp6_sendmld_out2			30
#define hkwd_icmp6_sendmld_out3			31
#define hkwd_icmp6_sendmld_out4			32
#define hkwd_ip6_copyoptions_in			33
#define hkwd_ip6_copyoptions_out		34
#define hkwd_ip6_ctloutput_in			35
#define hkwd_ip6_ctloutput_out			36
#define hkwd_ip6_deloption			37
#define hkwd_ip6_dropoption_in			38
#define hkwd_ip6_forward_in			39
#define hkwd_ip6_forward_out			40
#define hkwd_ip6_freemoptions_in		41
#define hkwd_ip6_getmoptions_in			42
#define hkwd_ip6_getmoptions_out		43
#define hkwd_ip6_getoptions_in			44
#define hkwd_ip6_getoptions_out			45
#define hkwd_ip6_init_in			46
#define hkwd_ip6_init_out			47
#define hkwd_ip6_input_in			48
#define hkwd_ip6_input_out			49
#define hkwd_ip6_insertoption_in		50
#define hkwd_ip6_insertoption_out		51
#define hkwd_ip6_mforward_in			52
#define hkwd_ip6_mforward_out			53
#define hkwd_ip6_mloopback_in			54
#define hkwd_ip6_mloopback_out			55
#define hkwd_ip6_output_in			56
#define hkwd_ip6_output_out			57
#define hkwd_ip6_reass_in			58
#define hkwd_ip6_reass_out			59
#define hkwd_ip6_saveoption_in			60
#define hkwd_ip6_saveoption_out			61
#define hkwd_ip6_setcontrol_in			62
#define hkwd_ip6_setcontrol_out			63
#define hkwd_ip6_setmoptions_in			64
#define hkwd_ip6_setmoptions_out		65
#define hkwd_ip6_setoptions_in			66
#define hkwd_ip6_setoptions_out			67
#define hkwd_ip6rttimeout_in			68
#define hkwd_ip6rttimeout_out			69
#define hkwd_ip6rttimer_in			70
#define hkwd_ip6rttimer_sched_in		71
#define hkwd_mfc_addqueue_in			72
#define hkwd_mfc_addqueue_out			73
#define hkwd_mfc_requeue_in			74
#define hkwd_mfc_requeue_out			75
#define hkwd_mfctimer_in			76
#define hkwd_mfctimer_out			77
#define hkwd_mroute6_init			78
#define hkwd_multicast_send_in			79
#define hkwd_multicast_send_out			80
#define hkwd_opt6_ctlinput_in			81
#define hkwd_opt6_ctlinput_out			82
#define hkwd_opt6_ferr_input			83
#define hkwd_opt6_haddr_input			84
#define hkwd_opt6_haddr_output			85
#define hkwd_opt6_init_in			86
#define hkwd_opt6_oerr_input			87
#define hkwd_opt6_reverse_in			88
#define hkwd_opt6_rtalert_input			89
#define hkwd_real_ip6_output_in			90	/* Unused */
#define hkwd_real_ip6_output_out		91	/* Unused */
#define hkwd_rt6_input_in			92
#define hkwd_rt6_input_out			93
#define hkwd_rt6_reverse_in			94
#define hkwd_rt6_reverse_out			95
#define hkwd_ip6_output_cachedroute        	96
#define hkwd_ip6_output_cachedroute_free   	97
#define hkwd_ip6_output_routetoif          	98
#define hkwd_ip6_output_netunreach         	99
#define hkwd_ip6_output_hostunreach        	100
#define hkwd_ip6_output_route_gwroute      	101
#define hkwd_ip6_output_mcast              	102
#define hkwd_ip6_output_mcast_noxface      	103
#define hkwd_ip6_output_mcast_hoplimit     	104
#define hkwd_ip6_output_sendit             	105
#define hkwd_ip6_output_nofrag_sent        	106
#define hkwd_ip6_output_frag_sent          	107
#define hkwd_ip6_output_bad                 	108
#define hkwd_llink_resolve_in                   109
#define hkwd_llink_resolve_out                  110
#define hkwd_ndp6_rtrequest_in                  111
#define hkwd_ndp6_rtrequest_out                 112
#define hkwd_ndp6_resolve_in                    113
#define hkwd_ndp6_resolve_out                   114
#define hkwd_ndsol6_output_in                   115
#define hkwd_ndsol6_output_out                  116
#define hkwd_ndadv6_output_in                   117
#define hkwd_ndadv6_output_out                  118
#define hkwd_redirect6_output_in                119
#define hkwd_redirect6_output_out               120
#define hkwd_ndsol6_input_in                    121
#define hkwd_ndsol6_input_out                   122
#define hkwd_ndadv6_input_in                    123
#define hkwd_ndadv6_input_out                   124
#define hkwd_rtsol6_input_in                    125
#define hkwd_rtsol6_input_out                   126
#define hkwd_rtadv6_input_in                    127
#define hkwd_rtadv6_input_out                   128
#define hkwd_redirect6_input_in                 129
#define hkwd_redirect6_input_out                130
#define hkwd_ip6_reachhint_in                   131
#define hkwd_ip6_reachhint_out                  132
#define hkwd_ndplookup_in                       133
#define hkwd_ndplookup_out                      134
#define hkwd_ndp6_ifinit_in                     135
#define hkwd_ndp6_ifinit_out                    136
#define hkwd_ndp6_rtlost_in                     137
#define hkwd_ndp6_rtlost_out                    138
#define hkwd_rip6_input_in                      139
#define hkwd_rip6_input_out                     140
#define hkwd_raw6_saverecv_in                   141
#define hkwd_raw6_saverecv_out                  142
#define hkwd_rip6_output_in                     143
#define hkwd_rip6_output_out                    144
#define hkwd_rip6_ctloutput_in                  145
#define hkwd_rip6_ctloutput_out                 146
#define hkwd_rip6_usrreq_in                     147
#define hkwd_rip6_usrreq_out                    148
#define hkwd_rip6_ctlinput_in                   149
#define hkwd_rip6_ctlinput_out1                 150
#define hkwd_rip6_ctlinput_out2                 151
#define hkwd_rip6_ctlinput_out3                 152
#define hkwd_rip6_ctlinput_out4                 153
#define hkwd_ip6_getctrlinfo_in			154
#define hkwd_ip6_getctrlinfo_out		155
#define hkwd_source_address_select_in		156
#define hkwd_source_address_select_out		157
#define hkwd_rip6_output_ancillary_in		158
#define hkwd_rip6_output_ancillary_out		159
#define hkwd_llink_resolve_nolock_in		160
#define hkwd_llink_resolve_nolock_out		161
#define hkwd_ip6_rtexpire_timeout_setup_in	162
#define hkwd_ip6_rtexpire_timeout_setup_out 	163
#define hkwd_ip6_rtexpire_netisr_in		164
#define hkwd_ip6_rtexpire_netisr_out		165
#define hkwd_ip6_ndsol_netisr_in                166
#define hkwd_ip6_ndsol_netisr_out1              167
#define hkwd_ip6_ndsol_netisr_out2              168
#define hkwd_in6_recvpathmtu_in                 169
#define hkwd_in6_recvpathmtu_bad                170
#define hkwd_in6_recvpathmtu_out                171
#define hkwd_in6_pcbnotifymtu_in                172
#define hkwd_in6_pcbnotifymtu_out               173
#define hkwd_ip6_setexthdroption_in             174
#define hkwd_ip6_setexthdroption_out            175
#define hkwd_ip6_getexthdroption_in             176
#define hkwd_ip6_getexthdroption_out            177
#define hkwd_raw6_saveopt_in                    178
#define hkwd_raw6_saveopt_bad                   179
#define hkwd_raw6_saveopt_out                   180
#define hkwd_mh6_input_in			181
#define hkwd_mh6_input_out			182
#define hkwd_ip6_reroute_in			183
#define hkwd_ip6_reroute_out			184



#define HKWD_PCB			0x53900000
#define hkwd_add_gateway_in			1
#define hkwd_add_gateway_out			2
#define hkwd_clear_ping_flags_in		3
#define hkwd_clear_ping_flags_out		4
#define hkwd_config_inet_in			5
#define hkwd_config_inet_out			6
#define hkwd_del_gateway_in			7
#define hkwd_del_gateway_nolock_in		8
#define hkwd_del_gateway_nolock_out		9
#define hkwd_del_gateway_out			10
#define hkwd_dgd_init_in			11
#define hkwd_dgd_init_out			12
#define hkwd_dgd_input6_in			13
#define hkwd_dgd_input6_out			14
#define hkwd_dgd_input_in			15
#define hkwd_dgd_input_out			16
#define hkwd_dgdretry_in			17
#define hkwd_dgdretry_out			18
#define hkwd_dgdretrysched_in			19
#define hkwd_dgdretrysched_out			20
#define hkwd_dgdsched_in			21
#define hkwd_dgdsched_out			22
#define hkwd_in6_addmulti_in			23
#define hkwd_in6_addmulti_out			24
#define hkwd_in6_control_in			25
#define hkwd_in6_control_out			26
#define hkwd_in6_delete_addrs_in		27
#define hkwd_in6_delete_addrs_out		28
#define hkwd_in6_delmulti_in			29
#define hkwd_in6_delmulti_out			30
#define hkwd_in6_ifattach_in			31
#define hkwd_in6_ifattach_out			32
#define hkwd_in6_ifinit_in			33
#define hkwd_in6_ifinit_out			34
#define hkwd_in6_ifscrub_in			35
#define hkwd_in6_ifscrub_out			36
#define hkwd_in6_pcbbind_dyn_in			37
#define hkwd_in6_pcbbind_dyn_out		38
#define hkwd_in6_pcbbind_in			39
#define hkwd_in6_pcbbind_out			43
#define hkwd_in6_pcbconnect_in			44
#define hkwd_in6_pcbconnect_out			47
#define hkwd_in6_pcblookup_in			48
#define hkwd_in6_pcblookup_out			51
#define hkwd_in6_pcbmatch_in			52
#define hkwd_in6_pcbmatch_out			53
#define hkwd_in6_pcbnotify_in			54
#define hkwd_in6_pcbnotify_out			55
#define hkwd_in6_pcbrebind_in			56
#define hkwd_in6_pcbrebind_out			57
#define hkwd_in6_rtalloc_in			58
#define hkwd_in6_rtalloc_out			59
#define hkwd_in6_rthost_in			60
#define hkwd_in6_rthost_out			61
#define hkwd_in6_setifa_in			62
#define hkwd_in6_setifa_out			63
#define hkwd_in_addmulti_in			64
#define hkwd_in_addmulti_out			65
#define hkwd_in_allpcbs_in			66
#define hkwd_in_allpcbs_out			67
#define hkwd_in_arpintr_in			68
#define hkwd_in_arpintr_out			69
#define hkwd_in_arpresolve_in			70
#define hkwd_in_control_in			71
#define hkwd_in_control_out			72
#define hkwd_in_delete_addrs_in			73
#define hkwd_in_delete_addrs_out		74
#define hkwd_in_delmulti_in			75
#define hkwd_in_delmulti_out			76
#define hkwd_in_hash_add_in			77
#define hkwd_in_hash_add_out			78
#define hkwd_in_hash_remove_in			79
#define hkwd_in_ifattach_in			80
#define hkwd_in_ifattach_out			81
#define hkwd_in_ifdetach_in			82
#define hkwd_in_ifdetach_out			83
#define hkwd_in_ifinit_in			84
#define hkwd_in_ifinit_out			85
#define hkwd_in_ifscrub_in			86
#define hkwd_in_losing_in			87
#define hkwd_in_losing_lock_in			88
#define hkwd_in_losing_lock_out			89
#define hkwd_in_losing_out			90
#define hkwd_in_pcb_hash_del_in			91
#define hkwd_in_pcb_hash_del_out		92
#define hkwd_in_pcb_hash_ins_in			93
#define hkwd_in_pcb_hash_ins_out		94
#define hkwd_in_pcb_tcp_hash_del_in		95
#define hkwd_in_pcb_tcp_hash_del_out		96
#define hkwd_in_pcb_tcp_lport_hash_ins_in	97
#define hkwd_in_pcb_tcp_lport_hash_ins_out	98
#define hkwd_in_pcballoc_in			99
#define hkwd_in_pcballoc_out			100
#define hkwd_in_pcbbind_in			101
#define hkwd_in_pcbbind_out			104
#define hkwd_in_pcbconnect_in			105
#define hkwd_in_pcbconnect_out			108
#define hkwd_in_pcbdetach_in			109
#define hkwd_in_pcbdetach_out			112
#define hkwd_in_pcbdisconnect_in		113
#define hkwd_in_pcbdisconnect_out		116
#define hkwd_in_pcbhashlookup2_in		121
#define hkwd_in_pcbhashlookup2_out		122
#define hkwd_in_pcbhashlookup_in		123
#define hkwd_in_pcbinit_in			124
#define hkwd_in_pcbinit_out			125
#define hkwd_in_pcblookup_in			126
#define hkwd_in_pcblookup_out			129
#define hkwd_in_pcbmatch_in			130
#define hkwd_in_pcbmatch_out			131
#define hkwd_in_pcbmovetotimewait_in		132
#define hkwd_in_pcbmovetotimewait_out		133
#define hkwd_in_pcbnotify_in			134
#define hkwd_in_pcbnotify_out			135
#define hkwd_in_pcbnotifyall_in			136
#define hkwd_in_pcbnotifyall_out		137
#define hkwd_in_rawpcbs_in			138
#define hkwd_in_rawpcbs_out			139
#define hkwd_in_rtchange_in			140
#define hkwd_in_rtchange_out			141
#define hkwd_in_rtinvalidate_in			142
#define hkwd_in_rtinvalidate_out		143
#define hkwd_in_setpeeraddr			144
#define hkwd_in_setsockaddr_in			145
#define hkwd_init_common_mtus_in		146
#define hkwd_mark_gateway_down_in		147
#define hkwd_mark_gateway_down_out		148
#define hkwd_ping_gateways_in			149
#define hkwd_ping_gateways_out			150
#define hkwd_ping_one_gateway_in		151
#define hkwd_ping_one_gateway_out		152
#define hkwd_set_ping_flag_in			153
#define hkwd_set_ping_flag_out			154
#define hkwd_tcp_bad_port_limit_init_in		155
#define hkwd_tcp_sendspace_change		156
#define hkwd_udp_bad_port_limit_init_in		157
#define hkwd_udp_sendspace_change		158
#define hkwd_in_pcbbind_sin			159
#define hkwd_in6_pcbbind_dyn_sin6		160
#define hkwd_in6_pcbbind_dyn_addr6		161
#define hkwd_in_pcb_pseudoconnect_in		162
#define hkwd_in_pcb_pseudoconnect_out		163
#define hkwd_in_pcb_pseudobind_in		164
#define hkwd_in_pcb_pseudobind_out		165
#define hkwd_in_pcb_pseudobind_sin		166
#define hkwd_in6_pcb_pseudoconnect_in		167
#define hkwd_in6_pcb_pseudoconnect_out		168
#define hkwd_in6_pcb_pseudobind_in		169
#define hkwd_in6_pcb_pseudobind_out		170
#define hkwd_in6_pcb_pseudobind_sin6		171
#define hkwd_in6_pcb_pseudobind_addr6		172
#define hkwd_in6_pcb_pseudorebind_in		173
#define hkwd_in6_pcb_pseudorebind_out		174
#define hkwd_in_pcbbind_port			175
#define hkwd_in6_pcbnotifyall_in		176
#define hkwd_in6_pcbnotifyall_out               177
#define hkwd_in6_pcbnotifyall_err_out           178
#define hkwd_in6_setmss_in                      179
#define hkwd_in6_setmss_out                     180
#define hkwd_in6_pmtuclone_in                   181
#define hkwd_in6_pmtuclone_out                  182
#define hkwd_in_pcblocalipnotify_in             183
#define hkwd_in_pcblocalipnotify_out            184


#define HKWD_MBUF		0x25400000
#define hkwd_m_get_in		1
#define hkwd_m_get_out		2
#define hkwd_m_getclr_in	3
#define hkwd_m_getclr_out	4
#define hkwd_m_free_in		5
#define hkwd_m_free_out		6
#define hkwd_m_copy_in		7
#define hkwd_m_copy_out		8
#define hkwd_m_copydata_in	9
#define hkwd_m_copydata_out	10
#define hkwd_m_pullup_1		11
#define hkwd_m_pullup_2		12
#define hkwd_mlowintr_in	13
#define hkwd_mlowintr_out	14
#define hkwd_m_low_test		15
#define hkwd_m_clgetm_in	16
#define hkwd_m_clgetm_out	17
#define hkwd_m_getclustm_in	18
#define hkwd_m_getclustm_out	19
#define hkwd_m_clattach_in	20
#define hkwd_m_clattach_out	21
#define hkwd_m_prepend_get_in	22
#define hkwd_m_prepend_get_out	23
#define hkwd_m_pullup_get_in	24
#define hkwd_m_pullup_get_out	25
#define hkwd_m_copy_get_in	26
#define hkwd_m_copy_get_out	27

/* These hook id's and sub hook id's are for Network Interface's */
#define HKWD_IFEN		0x25500000
#define HKWD_IFTR		0x25600000
#define HKWD_IFET		0x25700000
#define HKWD_IFXT		0x25800000
#define HKWD_IFSL		0x25900000
#define hkwd_statintr_in	1
#define hkwd_statintr_out	2	
#define hkwd_netintr_in		3
#define hkwd_netintr_out	4	
#define hkwd_attach_in		5
#define hkwd_attach_out		6
#define hkwd_detach_in		7
#define hkwd_detach_out		8
#define hkwd_init_in		9
#define hkwd_init_out		10
#define hkwd_ioctl_in		11
#define hkwd_ioctl_out		12
#define hkwd_output_in		13
#define hkwd_output_out		14
#define hkwd_reset_in		15
#define hkwd_reset_out		16
#define hkwd_rcv_in		17
#define hkwd_rcv_out		18
#define hkwd_incall_in		19
#define hkwd_incall_out		20	
#define hkwd_callcomp_in	21	
#define hkwd_callcomp_out	22
#define hkwd_clrind_in		23
#define hkwd_clrind_out		24
#define hkwd_slhiwat		25

/* This hook id is for TCP debug */
#define HKWD_TCPDBG		0x25a00000

#define HKWD_NET_MALLOC		0x34000000

#define hkwd_net_malloc		1
#define hkwd_net_free		2

/* This hook id is for ATM Socket Extensions */

#define HKWD_ATMSOCK		0x3A500000

/* These are TCPIP/FDDI related */
#define HKWD_IFCA		0x26000000
#define HKWD_IFSO		0x26100000
#define HKWD_IFFD		0x26200000
#define HKWD_DD_FDDIDD		0x26300000


/*
 * Data Link Control
 */
#define HKWD_SYSX_DLC_START       0x24000000 /* start link station    */
#define HKWD_SYSX_DLC_HALT        0x24100000 /* halt  link station    */
#define HKWD_SYSX_DLC_TIMER       0x24200000 /* timer                 */
#define HKWD_SYSX_DLC_XMIT        0x24300000 /* transmit packet       */
#define HKWD_SYSX_DLC_RECV        0x24400000 /* receive  packet       */
#define HKWD_SYSX_DLC_PERF        0x24500000 /* performance           */
#define HKWD_SYSX_DLC_MONITOR     0x24600000 /* monitor               */

#define HKWD_ODM_LIB              0x30000000 /* ODM code              */

/* hooks for STTY */
#define HKWD_STTY 		  0x40000000 
#define HKWD_STTY_STRTTY	  0x40100000 /* stream head tty */
#define HKWD_STTY_LDTERM 	  0x40200000 /* line discipline module */
#define HKWD_STTY_SPTR 		  0x40300000 /* serial printer discipline module */
#define HKWD_STTY_NLS 		  0x40400000 /* NLS mapping discipline module */
#define HKWD_STTY_PTY 		  0x40500000 /* pseudo tty driver */
#define HKWD_STTY_RS 		  0x40600000 /* RS driver */
#define HKWD_STTY_LION 		  0x40700000 /* LION driver */
#define HKWD_STTY_CXMA 		  0x40800000 /*  */
#define HKWD_STTY_ISA		  0x40900000 /* PCI/ISA native ports */

/* hooks till 0x40f00000 are reserved to stty for further use */

#define HKWD_VIRT_CONS            0x41700000 /* virtual console driver */

/* subhooks  for stty */
#define hkwd_TTY_CONFIG      0x01
#define hkwd_TTY_OPEN        0x02
#define hkwd_TTY_CLOSE       0x03
#define hkwd_TTY_WPUT        0x04
#define hkwd_TTY_RPUT        0x05
#define hkwd_TTY_WSRV        0x06
#define hkwd_TTY_RSRV        0x07
#define hkwd_TTY_REVOKE      0x08    /* for streamhead tty                   */
#define hkwd_TTY_IOCTL       0x09    /* for ioctls                           */
#define hkwd_TTY_PROC        0x0a    /* for drivers                          */
#define hkwd_TTY_SERVICE     0x0b    /* for drivers                          */
#define hkwd_TTY_SLIH        0x0c    /* for drivers                          */
#define hkwd_TTY_OFFL        0x0d    /* for drivers                          */
#define hkwd_TTY_LAST        0x0e    /* can be used for any specific entry   */

#define HKWD_CPU_PREEMPT 0x41900000	/* PHYP CPU preemption hook. */
/* Macros for the subhook */
#define _PRMT_REALLOC_M 0x8000		/* memory re-allocated */
#define _PRMT_WRAP_M 0x4000		/* preemption buffer wrapped */
#define _PRMT_CPUID_M 0xfff		/* cpu id */

/***********************************************************************/
/*************** DISPLAY SUBSYSTEM TRACE HOOK DEFINITIONS ************-*/
/***********************************************************************/
/*
 *  DISPLAY SUBSYSTEM MAJOR TRACE HOOKS
 *
 *  The display subsystem is divided into functional components.
 *  Each functional component is given two trace hooks.  The first
 *  trace hook is designated HKWD_xxx_P and is for performance trace.
 *  The second hook is designated HKWD_xxx_D and is for debug trace.
 *  The components of the display subsystem, for tracing purposes,
 *  are: Virtual Terminal Subsystem (VTSS); Rendering Context
 *  Manager (RCM); Device Dependent Functions of VTSS and RCM (DDF);
 *  Graphics Adapter Interface (GAI), which is divided into its
 *  subcomponents, 2D (GAI2DM1), Resource Management (GAIRMS),
 *  3D Model 1 (GAI3DM1), and 3D Model 2 (GAI3DM2); Enhanced X-Windows
 *  (X11); IBM's extensions to X (X11EXT); the SGI-like GL API (GL);
 *  and IBM graPHIGS (GRAPHIGS).
 *
 *  The trace hooks for display occupy the range 500 to 51F.  Further,
 *  the range 520-52F has been set aside in case the display subsystem
 *  requires additional growth.
 *
 *
 */

#define  HKWD_DISPLAY_VTSS_P           0x50000000  /*  display group  */
#define  HKWD_DISPLAY_VTSS_D           0x50100000
#define  HKWD_DISPLAY_RCM_P            0x50200000
#define  HKWD_DISPLAY_RCM_D            0x50300000
#define  HKWD_DISPLAY_DDF_P            0x50400000
#define  HKWD_DISPLAY_DDF_D            0x50500000
#define  HKWD_DISPLAY_GAIRMS_P         0x50600000
#define  HKWD_DISPLAY_GAIRMS_D         0x50700000
#define  HKWD_DISPLAY_GAI2DM1_P        0x50800000
#define  HKWD_DISPLAY_GAI2DM1_D        0x50900000
#define  HKWD_DISPLAY_GAI3DM1_P        0x50a00000
#define  HKWD_DISPLAY_GAI3DM1_D        0x50b00000
#define  HKWD_DISPLAY_GAI3DM2_P        0x50c00000
#define  HKWD_DISPLAY_GAI3DM2_D        0x50d00000
#define  HKWD_DISPLAY_X11_P            0x50e00000
#define  HKWD_DISPLAY_X11_D            0x50f00000
#define  HKWD_DISPLAY_X11EXT_P         0x51000000
#define  HKWD_DISPLAY_X11EXT_D         0x51100000
#define  HKWD_DISPLAY_GL_P             0x51200000
#define  HKWD_DISPLAY_GL_D             0x51300000
#define  HKWD_DISPLAY_GRAPHIGS_P       0x51400000
#define  HKWD_DISPLAY_GRAPHIGS_D       0x51500000
#define  HKWD_ACPA_P                   0x51600000
#define  HKWD_ACPA_D                   0x51700000
#define  HKWD_DISPLAY_RESERVED_518     0x51800000
#define  HKWD_DISPLAY_RESERVED_519     0x51900000
#define  HKWD_DISPLAY_RESERVED_51A     0x51a00000
#define  HKWD_DISPLAY_RESERVED_51B     0x51b00000
#define  HKWD_DISPLAY_RESERVED_51C     0x51c00000
#define  HKWD_DISPLAY_RESERVED_51D     0x51d00000
#define  HKWD_DISPLAY_RESERVED_51E     0x51e00000
#define  HKWD_DISPLAY_RESERVED_51F     0x51f00000

/*----------------------------------------------------------------
 *  DISPLAY SUBSYSTEM MINOR TRACE HOOKS
 *
 *  Each hookword occupies 32 bits.  The most significant 12 bits are
 *  the major hook ID.  The next four bits are reserved.  The least
 *  significant 16 bits are for component use.  The Display Subsystem
 *  uses the 16 bits to encode certain flags and to encode a minor
 *  hook ID.
 *
 *  The general format for the 16 bits of the minor hook ID is:
 *
 *  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
 *  |           routine ID              | func ID|ex|
 *  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
 *    0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15
 *
 *
 *  The first twelve bits are a routine ID, giving a maximum of
 *  4096 routines per component.  The next three bits are the
 *  function ID within the component.  Function 000 is always
 *  reserved for the main entry/exit to the routine.  Functions
 *  001 to 110 are for internal functions within the routine.
 *  In this sense, function can be used to encode data as well.
 *  Function 111 is a special code that permits the first word
 *  of trace data to hold an expanded internal function code.
 *
 *  Bit 15, "ex", is set to 0 upon entry to the routine/function.
 *  The bit is set to 1 upon exit of the function.  This permits
 *  entry/exit tracing without reuse of the routine ID.
 *
 */

/*------------------------------------------------------------------
 *  VTSS MINOR TRACE HOOK DEFINITION
 *
 *  The VTSS component is has several major functional pieces, including
 *  the HFT (an AIX character device driver), the Screen Manager, the
 *  Mode Processor, the Virtual Display Driver, the Keyboard Device
 *  Driver, and other input device drivers.
 *
 *-----------------------------------------------------------------*/

#define  hkwd_DISPLAY_VTSS_HFT_OPEN          ( 0x001 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_CLOSE         ( 0x002 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_IOCTL         ( 0x003 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_CONFIG        ( 0x004 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_MULTIPLEX     ( 0x005 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_SELECT        ( 0x006 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_READ          ( 0x007 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_WRITE         ( 0x008 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_REVOKE        ( 0x009 << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_INPUT         ( 0x00a << 4 )
#define  hkwd_DISPLAY_VTSS_HFT_OUTPUT        ( 0x00b << 4 )

#define  hkwd_DISPLAY_VTSS_VDD_ACT           ( 0x101 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_CFL           ( 0x102 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_CLR           ( 0x103 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_CPL           ( 0x104 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_DACT          ( 0x105 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_DEFC          ( 0x106 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_TERM          ( 0x107 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_INIT          ( 0x108 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_MOVC          ( 0x109 << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_RDS           ( 0x10a << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_TEXT          ( 0x10b << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_SCR           ( 0x10c << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_SETM          ( 0x10d << 4 )
#define  hkwd_DISPLAY_VTSS_VDD_STCT          ( 0x10e << 4 )

/*------------------------------------------------------------------
 *  GAI 2D Model 1 (GAI2DM1) MINOR TRACE HOOK DEFINITION
 *
 *  The minor IDs listed below are performance trace hooks
 *  for GAI 2D Model 1.
 *
 *  These functions are listed in the order specified in the             /
 *  2D Graphics Context Procedures structure.
 *
 *-----------------------------------------------------------------*/

#define  hkwd_DISPLAY_GAI2DM1_DESTROYGC             ( 1 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_ANALYZEGC             ( 2 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYPIXTOWIN          ( 3 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYWINTOPIX          ( 4 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYWINTOWIN          ( 5 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYPIXBPTOWIN        ( 6 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYWINBPTOPIX        ( 7 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_COPYWINBPTOWIN        ( 8 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYPOINT             ( 9 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYLINES             ( 10 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYSEGMENT           ( 11 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYRECTANGLE         ( 12 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYARC               ( 13 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_FILLPOLYGON           ( 14 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYFILLRECT          ( 15 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYFILLARC           ( 16 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_PUTIMAGE              ( 17 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_IMAGETEXT8            ( 18 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYTEXT8             ( 19 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_IMAGETEXT16           ( 20 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_POLYTEXT16            ( 21 << 4 )
#define  hkwd_DISPLAY_GAI2DM1_PUSHPIXELS            ( 22 << 4 )

/*------------------------------------------------------------------
 *  M-ACPA/A MINOR TRACK HOOK DEFINITION
 *
 *  The minor IDs listed below are performance trace hooks
 *  for the Mulitmedia Audio Capture and Playback Adapter.
 *
 *-----------------------------------------------------------------*/

#define  hkwd_ACPA_CFGINIT                      ( 1 << 4 )
#define  hkwd_ACPA_CFGTERM                      ( 2 << 4 )
#define  hkwd_ACPA_OPEN                         ( 3 << 4 )
#define  hkwd_ACPA_CLOSE                        ( 4 << 4 )
#define  hkwd_ACPA_INTERRUPT                    ( 5 << 4 )
#define  hkwd_ACPA_READ                         ( 6 << 4 )
#define  hkwd_ACPA_WRITE                        ( 7 << 4 )
#define  hkwd_ACPA_IOCTL                        ( 8 << 4 )
#define  hkwd_ACPA_MPX                          ( 9 << 4 )
#define  hkwd_ACPA_SELECT                       ( 10 << 4 )
#define  hkwd_ACPA_INIT                         ( 11 << 4 )
#define  hkwd_ACPA_CHANGE                       ( 12 << 4 )
#define  hkwd_ACPA_START                        ( 13 << 4 )
#define  hkwd_ACPA_STOP                         ( 14 << 4 )
#define  hkwd_ACPA_PAUSE                        ( 15 << 4 )
#define  hkwd_ACPA_RESUME                       ( 16 << 4 )
#define  hkwd_ACPA_STATUS                       ( 17 << 4 )
#define  hkwd_ACPA_WAIT                         ( 18 << 4 )
#define  hkwd_ACPA_BUFFER                       ( 19 << 4 )
#define  hkwd_ACPA_LOAD                         ( 20 << 4 )
#define  hkwd_ACPA_DEVSTART                     ( 21 << 4 )
#define  hkwd_ACPA_DEVSTOP                      ( 22 << 4 )
#define  hkwd_ACPA_INITZ                        ( 23 << 4 )
#define  hkwd_ACPA_TIMEDOUT                     ( 24 << 4 )

/***********************************************************************/
/************ END OF DISPLAY SUBSYSTEM TRACE HOOK DEFINITIONS ********-*/
/***********************************************************************/

/* Netbios */

#define HKWD_NB_TRACE_NCB 		0x28300000
#define HKWD_NB_TRACE_IOB		0x28400000
#define HKWD_NB_TRACE_OPEN 	 	0x28500000
#define HKWD_NB_TRACE_COMM	 	0x28600000
#define HKWD_NB_TRACE_WRITE 		0x28700000
#define HKWD_NB_TRACE_READ 		0x28800000
#define HKWD_NB_TRACE_DATA	 	0x28900000
#define HKWD_NB_TRACE_MIF	 	0x28a00000
#define HKWD_NB_TRACE_VALUE		0x28b00000

/* Hook for kernel profiling */
#define HKWD_KERN_PROF		0x23400000  /* capture iar at clock intr */

/* Hooks for COBOL */
#define HKWD_COB                        0x23500000
#define HKWD_COB_RTE                    0x23600000
#define HKWD_COB_APPL                   0x23700000

/* Hooks for PSLA */
#define HKWD_PSLA_OPEN                  0x27200000
#define HKWD_PSLA_CLOSE                 0x27300000
#define HKWD_PSLA_READ                  0x27400000
#define HKWD_PSLA_WRITE                 0x27500000
#define HKWD_PSLA_IOCTL                 0x27600000
#define HKWD_PSLA_INTR                  0x27700000
#define HKWD_PSLA_CONF			0x27800000

/* Hook for NCS */
#define HKWD_NCS_NCK                    0x27900000

/* Hooks for SNA */
#define HKWD_SNA_COMM                   0x27000000
#define HKWD_SNA_API                    0x27100000
#define HKWD_GSNA_API                   0x28100000
#define HKWD_SNALIB_API                 0x28200000

/* Hooks for SYSXMSLA */
#define HKWD_HIA			0x28000000

/* Hook for Netview */
#define HKWD_NETVIEW_6000               0x29000000

/* Hook for Hursley */
#define HKWD_HSTC_PRD                   0x29100000

/* Hook for SYSXVCA */
#define HKWD_VCA_DD			0x29200000

/* VCA sub hook ids */
#define hkwd_VCA_ENTRY_OPEN			0x1
#define hkwd_VCA_EXIT_OPEN			0x2
#define hkwd_VCA_ENTRY_CLOSE			0x3
#define hkwd_VCA_EXIT_CLOSE			0x4
#define hkwd_VCA_ENTRY_READ			0x5
#define hkwd_VCA_EXIT_READ			0x6
#define hkwd_VCA_ENTRY_WRITE			0x7
#define hkwd_VCA_EXIT_WRITE			0x8
#define hkwd_VCA_ENTRY_CONFIG			0x9
#define hkwd_VCA_EXIT_CONFIG			0xA
#define hkwd_VCA_ENTRY_IOCTL			0xB
#define hkwd_VCA_EXIT_IOCTL			0xC
#define hkwd_VCA_ENTRY_VCA_SETUP		0xD
#define hkwd_VCA_EXIT_VCA_SETUP			0xE
#define hkwd_VCA_ENTRY_VCA_MEMCOPY		0xF
#define hkwd_VCA_EXIT_VCA_MEMCOPY		0x10
#define hkwd_VCA_ENTRY_MEM_SETUP		0x11
#define hkwd_VCA_EXIT_MEM_SETUP			0x12
#define hkwd_VCA_ENTRY_MEM_UNSET		0x13
#define hkwd_VCA_EXIT_MEM_UNSET			0x14
#define hkwd_VCA_ENTRY_GETSTATUS		0x15
#define hkwd_VCA_EXIT_GETSTATUS			0x16
#define hkwd_VCA_ENTRY_SETMASK			0x17
#define hkwd_VCA_EXIT_SETMASK			0x18
#define hkwd_VCA_ENTRY_CAPTURE_WAIT		0x19
#define hkwd_VCA_EXIT_CAPTURE_WAIT		0x1A
#define hkwd_VCA_ENTRY_INTR_ENABLE		0x1B
#define hkwd_VCA_EXIT_INTR_ENABLE		0x1C
#define hkwd_VCA_ENTRY_INTR_DISABLE		0x1D
#define hkwd_VCA_EXIT_INTR_DISABLE		0x1E
#define hkwd_VCA_ENTRY_VCA_SET_MODE		0x1F
#define hkwd_VCA_EXIT_VCA_SET_MODE		0x20
#define hkwd_VCA_ENTRY_VCA_SET_CONTROLS		0x21
#define hkwd_VCA_EXIT_VCA_SET_CONTROLS		0x22
#define hkwd_VCA_ENTRY_VCA_SET_CURSOR		0x23
#define hkwd_VCA_EXIT_VCA_SET_CURSOR		0x24
#define hkwd_VCA_ENTRY_VCA_SET_WINDOW		0x25
#define hkwd_VCA_EXIT_VCA_SET_WINDOW		0x26
#define hkwd_VCA_ENTRY_VCA_SET_DACS		0x27
#define hkwd_VCA_EXIT_VCA_SET_DACS		0x28
#define hkwd_VCA_ENTRY_ALTDAC			0x29
#define hkwd_VCA_EXIT_ALTDAC			0x2A
#define hkwd_VCA_ENTRY_VCA_GET_MODE		0x2B
#define hkwd_VCA_EXIT_VCA_GET_MODE		0x2C
#define hkwd_VCA_ENTRY_VCA_GET_CONTROLS		0x2D
#define hkwd_VCA_EXIT_VCA_GET_CONTROLS		0x2E
#define hkwd_VCA_ENTRY_VCA_GET_CURSOR		0x2F
#define hkwd_VCA_EXIT_VCA_GET_CURSOR		0x30
#define hkwd_VCA_ENTRY_VCA_GET_WINDOW		0x31
#define hkwd_VCA_EXIT_VCA_GET_WINDOW		0x32
#define hkwd_VCA_ENTRY_VCA_GET_DACS		0x33
#define hkwd_VCA_EXIT_VCA_GET_DACS		0x34
#define hkwd_VCA_ENTRY_READDAC			0x35
#define hkwd_VCA_EXIT_READDAC			0x36
#define hkwd_VCA_ENTRY_VCA_SET_DAC_DEFAULTS	0x37
#define hkwd_VCA_EXIT_VCA_SET_DAC_DEFAULTS	0x38
#define hkwd_VCA_ENTRY_VCA_INTR			0x39
#define hkwd_VCA_EXIT_VCA_INTR			0x3A
#define hkwd_VCA_ENTRY_VCA_OUTB			0x3B
#define hkwd_VCA_EXIT_VCA_OUTB			0x3C
#define hkwd_VCA_ENTRY_VCA_INB			0x3D
#define hkwd_VCA_EXIT_VCA_INB			0x3E
#define hkwd_VCA_ENTRY_VCA_TIMED_OUT		0x3F
#define hkwd_VCA_EXIT_VCA_TIMED_OUT		0x40
#define hkwd_VCA_ENTRY_VCA_ALTREG		0x41
#define hkwd_VCA_EXIT_VCA_ALTREG		0x42
#define hkwd_VCA_ENTRY_VCA_READREG		0x43
#define hkwd_VCA_EXIT_VCA_READREG		0x44
#define hkwd_VCA_ENTRY_VCA_KSET_CURSOR		0x45
#define hkwd_VCA_EXIT_VCA_KSET_CURSOR		0x46
#define hkwd_VCA_ENTRY_VCA_KGET_CURSOR		0x47
#define hkwd_VCA_EXIT_VCA_KGET_CURSOR		0x48
#define hkwd_VCA_ENTRY_VCA_DELAY		0x49
#define hkwd_VCA_EXIT_VCA_DELAY			0x4A
#define hkwd_VCA_ENTRY_VCA_INITIALIZE		0x4B
#define hkwd_VCA_EXIT_VCA_INITIALIZE		0x4C
#define hkwd_VCA_ENTRY_VCAERR			0x4D
#define hkwd_VCA_EXIT_VCAERR			0x4E

/*
 * STREAMS (PSE) Hookwords
 */

#define	HKWD_PSE		0x7FF00000

/* system calls */
#define	hkwd_pse_getmsg_in	0x01
#define	hkwd_pse_getmsg_out	0x02
#define	hkwd_pse_getpmsg_in	0x03
#define	hkwd_pse_getpmsg_out	0x04
#define	hkwd_pse_putmsg_in	0x05
#define	hkwd_pse_putmsg_out	0x06
#define	hkwd_pse_putpmsg_in	0x07
#define	hkwd_pse_putpmsg_out	0x08

/* driver entry points */
#define	hkwd_pse_open_in	0x09
#define	hkwd_pse_open_out	0x0a
#define	hkwd_pse_clone_in	0x0b
#define	hkwd_pse_clone_out	0x0c
#define	hkwd_pse_close_in	0x0d
#define	hkwd_pse_close_out	0x0e
#define	hkwd_pse_read_in	0x0f
#define	hkwd_pse_read_out	0x10
#define	hkwd_pse_write_in	0x11
#define	hkwd_pse_write_out	0x12
#define	hkwd_pse_ioctl_in	0x13
#define	hkwd_pse_ioctl_out	0x14
#define	hkwd_pse_poll_in	0x15
#define	hkwd_pse_poll_out	0x16

/* hooks for thread-based services */
#define HKWD_KERN_ASSERTWAIT		0x46000000
#define HKWD_KERN_CLEARWAIT		0x46100000
#define HKWD_KERN_THREADBLOCK		0x46200000
#define HKWD_KERN_EMPSLEEP		0x46300000
#define HKWD_KERN_EWAKEUPONE		0x46400000
#define HKWD_SYSC_CRTHREAD		0x46500000
#define HKWD_KERN_KTHREADSTART		0x46600000
#define HKWD_SYSC_TERMTHREAD  		0x46700000
#define HKWD_KERN_KSUSPEND    		0x46800000
#define HKWD_SYSC_THREADSETSTATE    	0x46900000
#define HKWD_SYSC_THREADTERM_ACK    	0x46A00000
#define HKWD_SYSC_THREADSETSCHED    	0x46B00000
#define HKWD_KERN_TIDSIG    		0x46C00000
#define HKWD_KERN_WAITLOCK  		0x46D00000
#define HKWD_KERN_WAKEUPLOCK		0x46E00000
#define HKWD_SYSC_THREADLOCKBOOST    	0x47600000
#define HKWD_KERN_WAITLOCKLOCAL         0x47700000

/* Hook for PCMCIA Socket Services */
#define	HKWD_PCMCIA_SS			0x23000000
/* Hook for PCMCIA Card Services */
#define	HKWD_PCMCIA_CS			0x34300000

/* Hooks for SECURITY */
#define HKWD_SEC			0x3B700000  /* Security major events */
#define HKWD_SEC_DATA			0x3B800000  /* Security data events  */
#define HKWD_SEC_CRED			0x52F00000  /* Security credential alloc/dealloc  */

/* Hook for Network Buffer Cache */
#define HKWD_NBC			0x2ED00000  /* Network Buffer Cache */

/* Hook Word for WLM */
#define HKWD_WLM_STAGE1			0x2F900000  /* Workload Management */

/*
 * RAS: high availability services
 */

#define HKWD_RPDP		0x2FD00000	    /* RPDP */
/* RPDP with sub-hook-ID-s */
#define HKWD_RPDP_START		(HKWD_RPDP | 0)	    /* RPDP start */
#define HKWD_RPDP_ABORT		(HKWD_RPDP | 1)	    /* RPDP aborted */
#define HKWD_RPDP_SUCCESS	(HKWD_RPDP | 2)	    /* RPDP successfully done */
#define HKWD_RPDP_HAEH		(HKWD_RPDP | 0x10)  /* HA handler: ACCEPTED */
#define HKWD_RPDP_HAEH_BAD	(HKWD_RPDP | 0x11)  /* HA handler: REFUSED */
#define HKWD_RPDP_IT_REROUTE	(HKWD_RPDP | 0x20)  /* Interrupt re-route */
#define HKWD_RPDP_CPUSWAP	(HKWD_RPDP | 0x30)  /* CPU swap takes place */
#define HKWD_RPDP_TRB_MIGR	(HKWD_RPDP | 0x40)  /* Timer migrated */
#define HKWD_RPDP_STOP_SELF	(HKWD_RPDP | 0x50)  /* pal_stop_myself() */

#define	HKWD_SYSFR		0x2FE00000	    /* System freeze */
/* System freeze with sub-hook-ID-s */
#define HKWD_SYSFR_START	(HKWD_SYSFR | 0)    /* System freeze start */
#define HKWD_SYSFR_END		(HKWD_SYSFR | 1)    /* System freeze end */
#define HKWD_SYSFR_MASTER_START	(HKWD_SYSFR | 0x20) /* Freeze master start */
#define HKWD_SYSFR_MASTER_END	(HKWD_SYSFR | 0x21) /* Freeze master end */
#define HKWD_SYSFR_SLAVE_START	(HKWD_SYSFR | 0x30) /* Fr. slave command start*/
#define HKWD_SYSFR_SLAVE_END	(HKWD_SYSFR | 0x31) /* Fr. slave command end */
#define HKWD_SYSFR_BLOCK_IT	(HKWD_SYSFR | 0x40) /* Block ext. interrupts */
#define HKWD_SYSFR_ENABLE_IT	(HKWD_SYSFR | 0x41) /* Enable ext. interrupts */
#define HKWD_SYSFR_DIS_PLVL	(HKWD_SYSFR | 0x50) /*Before pal_i_disableplvl*/
#define HKWD_SYSFR_DIS_PLVL_END	(HKWD_SYSFR | 0x51) /* After pal_i_disableplvl*/
#define HKWD_SYSFR_EN_PLVL	(HKWD_SYSFR | 0x60) /* Before pal_i_enableplvl*/
#define HKWD_SYSFR_EN_PLVL_END	(HKWD_SYSFR | 0x61) /* After pal_i_enableplvl */

/*
 * Dynamic Reconfiguration
 */
#define HKWD_DR			0x38F00000	    /* DR */

/* subhook ids */

#define hkwd_DR_REGISTER		1
#define hkwd_REGISTER_DR_EVENT		2
#define hkwd_DR_NOTIFY			3
#define hkwd_DR_UNREGISTER		4
#define hkwd_UNREGISTER_DR_EVENT	5
#define hkwd_DR_RECONFIG		6

#define hkwd_RECONFIG_REGISTER_ENTRY	20
#define hkwd_RECONFIG_REGISTER_EXIT	21
#define hkwd_RECONFIG_UNREGISTER_ENTRY	22
#define hkwd_RECONFIG_UNREGISTER_EXIT	23
#define hkwd_RECONFIG_COMPLETE_ENTRY	24
#define hkwd_RECONFIG_COMPLETE_HNAME	25
#define hkwd_RECONFIG_COMPLETE_EXIT	26

#define hkwd_INVOKE_HANDLERS_ENTRY	40
#define hkwd_INVOKE_HANDLERS_SLEEP	41
#define hkwd_INVOKE_HANDLERS_AWAKE	42

#define hkwd_MPC_REMOVE_HANDLER		50
#define hkwd_MPC_FREEZE_HANDLER		51

#define hkwd_SEND_SIGNAL		60
#define hkwd_NPROC_POSTED		61

#define hkwd_GET_USER_DATA		70
#define hkwd_DR_CALLOUT			71
#define hkwd_VALIDATE_PHASE		72
#define hkwd_VALIDATE_NOTIFY		73
#define hkwd_RUN_NOTIFY			74
#define hkwd_KERNEL_NOTIFY		75
#define hkwd_CLEAR_DRPARMS		76

#define hkwd_HA_PROC			90
#define hkwd_HA_PROC_FAIL_LCPU		91
#define hkwd_DR_FAIL_LCPU_STATUS	92
#define hkwd_DR_MIGRATE_WDOGS		93
#define hkwd_DR_SEND_SIGCPUFAIL		94

#define hkwd_ADDCPU_VALIDATE		100
#define hkwd_ADDCPU_PRE			101
#define hkwd_ADDCPU_CLEANUP		102
#define hkwd_ADDCPU_DOIT		103
#define hkwd_DR_START_CPU		104
#define hkwd_DR_MAIN_BS_PROC		105
#define hkwd_DR_VMM_INIT		106
#define hkwd_DR_UPDATE_PNDA		107
#define hkwd_DR_REROUTE_IT		108

#define hkwd_DR_RM_ATTACH		120
#define hkwd_DR_MIGR_CLASS_ANY		121
#define hkwd_DR_STOP_LCPU		122
#define hkwd_DR_MOVE_THREADS		123
#define hkwd_RMCPU_VALIDATE		124
#define hkwd_RMCPU_PRE			125
#define hkwd_RMCPU_DOIT			126
#define hkwd_RMCPU_CLEANUP		127
#define hkwd_DR_CONTROLING_LCPU		128
#define hkwd_CALL_HA_HANDLERS		129
#define hkwd_DISABLE_DECR		130
#define hkwd_ENABLE_DECR		131
#define hkwd_DR_NEW_MASTER_LCPU		132
#define hkwd_RMCPU_STATUS		133

#define hkwd_FIND_DUMMY_PPDA		140
#define hkwd_SCPU_VALIDATE		141
#define hkwd_SCPU_DOIT			142
#define hkwd_SCPU_START			143
#define hkwd_SCPU_SUCCESS		144
#define hkwd_FAIL_CPU_STOPPED		145


/* hooks for security development */

#define hkwd_SEC_GETCONFATTR_ENTRY	10
#define hkwd_SEC_GETCONFATTR_FAILURE	11
#define hkwd_SEC_GETCONFATTR_SUCCESS	12
#define hkwd_SEC_GETGROUPATTR_ENTRY	20
#define hkwd_SEC_GETGROUPATTR_FAILURE	21
#define hkwd_SEC_GETGROUPATTR_SUCCESS	22
#define hkwd_SEC_PUTGROUPATTR_ENTRY	30
#define hkwd_SEC_PUTGROUPATTR_FAILURE	31
#define hkwd_SEC_PUTGROUPATTR_SUCCESS	32
#define hkwd_SEC_IDTOGROUP_ENTRY	40
#define hkwd_SEC_IDTOGROUP_SUCCESS	41
#define hkwd_SEC_IDTOGROUP_FAILURE	42
#define hkwd_SEC_GROUPTOID_ENTRY	50
#define hkwd_SEC_GROUPTOID_SUCCESS	51
#define hkwd_SEC_GROUPTOID_FAILURE	52
#define hkwd_SEC_IDTOUSER_ENTRY		60
#define hkwd_SEC_IDTOUSER_FAILURE	61
#define hkwd_SEC_IDTOUSER_SUCCESS	62
#define hkwd_SEC_GETUSERATTR_ENTRY	70
#define hkwd_SEC_GETUSERATTR_FAILURE	71
#define hkwd_SEC_GETUSERATTR_SUCCESS	72
#define hkwd_SEC_PUTUSERATTR_ENTRY	80
#define hkwd_SEC_PUTUSERATTR_FAILURE	81
#define hkwd_SEC_PUTUSERATTR_SUCCESS	82
#define hkwd_SEC_GETUSERPW_ENTRY	90
#define hkwd_SEC_GETUSERPW_SUCCESS	91
#define hkwd_SEC_GETUSERPW_FAILURE	92
#define hkwd_SEC_PUTUSERPW_ENTRY	100
#define hkwd_SEC_PUTUSERPW_FAILURE	101
#define hkwd_SEC_PUTUSERPW_SUCCESS	102
#define hkwd_SEC_GETGENERICATTR_ENTRY	110
#define hkwd_SEC_GETGENERICATTR_RETURN	112
#define hkwd_SEC_PUTGENERICATTR_ENTRY	120
#define hkwd_SEC_PUTGENERICATTR_RETURN	122
#define hkwd_SEC_GETPENV_ENTRY		130
#define hkwd_SEC_GETPENV_FAILURE	131
#define hkwd_SEC_GETPENV_SUCCESS	132
#define hkwd_SEC_SETPENV_ENTRY		140
#define hkwd_SEC_SETPENV_FAILURE	141
#define hkwd_SEC_SETPENV_SUCCESS	142
#define hkwd_SEC_SETPCRED_ENTRY		150
#define hkwd_SEC_SETPCRED_FAILURE	151
#define hkwd_SEC_SETPCRED_SUCCESS	152
#define hkwd_SEC_GETPCRED_ENTRY		160
#define hkwd_SEC_GETPCRED_FAILURE	161
#define hkwd_SEC_GETPCRED_SUCCESS	162
#define hkwd_SEC_AUTHENTICATE_ENTRY	170
#define hkwd_SEC_AUTHENTICATE_MACRO	171
#define hkwd_SEC_AUTHENTICATE_GRAMMAR	173
#define hkwd_SEC_GETPWNAM_R_ENTRY	180
#define hkwd_SEC_GETPWNAM_R_RETURN	181
#define hkwd_SEC_GETPWUID_R_ENTRY	190
#define hkwd_SEC_GETPWUID_R_RETURN	191
#define hkwd_SEC_GETPWENT_R_ENTRY	200
#define hkwd_SEC_GETPWENT_R_RETURN	201
#define hkwd_SEC_GETGRNAM_R_ENTRY	210
#define hkwd_SEC_GETGRGID_R_ENTRY	220
#define hkwd_SEC_GETGRGID_R_RETURN	221
#define hkwd_SEC_GETGRENT_R_ENTRY	230

/* PKI Service Module Sub-hook IDs */
#define hkwd_SEC_PKIMQUERYVERSIONS_ENTRY	244
#define hkwd_SEC_PKIMQUERYVERSIONS_FAILURE	245
#define hkwd_SEC_PKIMQUERYVERSIONS_SUCCESS	246
#define hkwd_SEC_PKIMERRORMODTEXT_ENTRY		247
#define hkwd_SEC_PKIMERRORMODTEXT_FAILURE	248
#define hkwd_SEC_PKIMERRORMODTEXT_SUCCESS	249
#define hkwd_SEC_PKIMLISTBUILD_ENTRY		250
#define hkwd_SEC_PKIMLISTBUILD_FAILURE		251
#define hkwd_SEC_PKIMLISTBUILD_SUCCESS		252
#define hkwd_SEC_PKIMLISTFREE_ENTRY		253
#define hkwd_SEC_PKIMLISTFREE_SUCCESS		255
#define hkwd_SEC_PKIMLISTLOADSRV_ENTRY		256
#define hkwd_SEC_PKIMLISTLOADSRV_FAILURE	257
#define hkwd_SEC_PKIMLISTLOADSRV_SUCCESS	258
#define hkwd_SEC_PKIMCERTCREATE_ENTRY		260
#define hkwd_SEC_PKIMCERTCREATE_FAILURE		261
#define hkwd_SEC_PKIMCERTCREATE_SUCCESS		262
#define hkwd_SEC_PKIMCERTREVOKE_ENTRY		263
#define hkwd_SEC_PKIMCERTREVOKE_FAILURE		264
#define hkwd_SEC_PKIMCERTREVOKE_SUCCESS		265
#define hkwd_SEC_PKIMCERTVERIFY_ENTRY		266
#define hkwd_SEC_PKIMCERTVERIFY_FAILURE		267
#define hkwd_SEC_PKIMCERTVERIFY_SUCCESS		268
#define hkwd_SEC_PKIMKSCHPASSWD_ENTRY		269
#define hkwd_SEC_PKIMKSCHPASSWD_FAILURE		270
#define hkwd_SEC_PKIMKSCHPASSWD_SUCCESS		271
#define hkwd_SEC_PKIMKSPASSWDRULES_ENTRY	272
#define hkwd_SEC_PKIMKSPASSWDRULES_FAILURE	273
#define hkwd_SEC_PKIMKSPASSWDRULES_SUCCESS	274
#define hkwd_SEC_PKIMKSVRFYPASSWD_ENTRY		275
#define hkwd_SEC_PKIMKSVRFYPASSWD_FAILURE	276
#define hkwd_SEC_PKIMKSVRFYPASSWD_SUCCESS	277
#define hkwd_SEC_PKIMKSCPOBJECTS_ENTRY		278
#define hkwd_SEC_PKIMKSCPOBJECTS_FAILURE	279
#define hkwd_SEC_PKIMKSCPOBJECTS_SUCCESS	280
#define hkwd_SEC_PKIMKSLSOBJECTS_ENTRY		281
#define hkwd_SEC_PKIMKSLSOBJECTS_FAILURE	282
#define hkwd_SEC_PKIMKSLSOBJECTS_SUCCESS	283
#define hkwd_SEC_PKIMKSRMOBJECTS_ENTRY		284
#define hkwd_SEC_PKIMKSRMOBJECTS_FAILURE	285
#define hkwd_SEC_PKIMKSRMOBJECTS_SUCCESS	286
#define hkwd_SEC_PKIMUSERCREATE_ENTRY		287
#define hkwd_SEC_PKIMUSERCREATE_FAILURE		288
#define hkwd_SEC_PKIMUSERCREATE_SUCCESS		289
#define hkwd_SEC_PKIMUSERDISABLE_ENTRY		290
#define hkwd_SEC_PKIMUSERDISABLE_FAILURE	291
#define hkwd_SEC_PKIMUSERDISABLE_SUCCESS	292
#define hkwd_SEC_PKIMQUERYMETHODS_ENTRY		293
#define hkwd_SEC_PKIMQUERYMETHODS_FAILURE	294
#define hkwd_SEC_PKIMQUERYMETHODS_SUCCESS	295
#define hkwd_SEC_PKIMCTRLCLEANUP_ENTRY		296
#define hkwd_SEC_PKIMCTRLCLEANUP_FAILURE	297
#define hkwd_SEC_PKIMCTRLCLEANUP_SUCCESS	298


/* PKI Toolkit Library Sub-hook IDs */

#define hkwd_SEC_PKIT_FUNC_ENTRY	300
#define hkwd_SEC_PKIT_FUNC_INFO		301
#define hkwd_SEC_PKIT_FUNC_FAILURE	302
#define hkwd_SEC_PKIT_FUNC_SUCCESS	303

/* PKI Load Module Sub-hook IDs */

#define hkwd_SEC_PKIL_FUNC_ENTRY	304
#define hkwd_SEC_PKIL_FUNC_INFO		305
#define hkwd_SEC_PKIL_FUNC_FAILURE	306
#define hkwd_SEC_PKIL_FUNC_SUCCESS	307

/* PKI Certificate and Key Management Commands Sub-hook IDs */

#define hkwd_SEC_CERT_COMMANDS_FUNC_ENTRY	320
#define hkwd_SEC_CERT_COMMANDS_FUNC_SUCCESS	321
#define hkwd_SEC_CERT_COMMANDS_FUNC_FAIL	322
#define hkwd_SEC_CERT_COMMANDS_FUNC_INFO	323


#define hkwd_SEC_ACCESSX_ENTRY		10000
#define hkwd_SEC_ACCESSX_EXIT		10001
#define hkwd_SEC_FACCESSX_ENTRY		10010
#define hkwd_SEC_FACCESSX_EXIT		10011
#define hkwd_SEC_AUDIT_ENTRY		10020
#define hkwd_SEC_AUDIT_EXIT		10021
#define hkwd_SEC_AUDITBIN_ENTRY		10030
#define hkwd_SEC_AUDITBIN_EXIT		10031
#define hkwd_SEC_AUDITLOG_ENTRY		10040
#define hkwd_SEC_AUDITLOG_EXIT		10041
#define hkwd_SEC_AUDITEVENTS_ENTRY	10050
#define hkwd_SEC_AUDITEVENTS_EXIT	10051
#define hkwd_SEC_AUDITPROC_ENTRY	10060
#define hkwd_SEC_AUDITPROC_EXIT		10061
#define hkwd_SEC_AUDITPROC_ERROR	10062
#define hkwd_SEC_CHACL_ENTRY		10070
#define hkwd_SEC_CHACL_EXIT		10071
#define hkwd_SEC_FCHACL_ENTRY		10080
#define hkwd_SEC_FCHACL_EXIT		10081
#define hkwd_SEC_CHPRIV_ENTRY		10090
#define hkwd_SEC_CHPRIV_EXIT		10091
#define hkwd_SEC_FCHPRIV_ENTRY		10100
#define hkwd_SEC_FCHPRIV_EXIT		10101
#define hkwd_SEC_PRIVCHECK_ENTRY	10110
#define hkwd_SEC_PRIVCHECK_EXIT		10111
#define hkwd_SEC_REVOKE_ENTRY		10120
#define hkwd_SEC_REVOKE_EXIT		10121
#define hkwd_SEC_FREVOKE_ENTRY		10130
#define hkwd_SEC_FREVOKE_EXIT		10131
#define hkwd_SEC_STATACL_ENTRY		10140
#define hkwd_SEC_STATACL_EXIT		10141
#define hkwd_SEC_FSTATACL_ENTRY		10150
#define hkwd_SEC_FSTATACL_EXIT		10151
#define hkwd_SEC_STATPRIV_ENTRY		10160
#define hkwd_SEC_STATPRIV_EXIT		10161
#define hkwd_SEC_FSTATPRIV_ENTRY	10170
#define hkwd_SEC_FSTATPRIV_EXIT		10171
#define	hkwd_SEC_FSTATACLX_ENTRY	10172
#define	hkwd_SEC_FSTATACLX_EXIT		10173
#define	hkwd_SEC_FCHACLX_ENTRY		10174
#define	hkwd_SEC_FCHACLX_EXIT		10175
#define	hkwd_SEC_CHACLX_ENTRY		10176
#define	hkwd_SEC_CHACLX_EXIT		10177
#define hkwd_SEC_STATACLX_ENTRY		10178
#define	hkwd_SEC_STATACLX_EXIT		10179
#define	hkwd_SEC_FCHXACL_ENTRY		10180
#define	hkwd_SEC_FCHXACL_EXIT		10181
#define	hkwd_SEC_CHXACL_ENTRY		10182
#define	hkwd_SEC_CHXACL_EXIT		10183
#define	hkwd_SEC_FSTATXACL_ENTRY	10184
#define	hkwd_SEC_FSTATXACL_EXIT		10185
#define	hkwd_SEC_STATXACL_ENTRY		10186
#define	hkwd_SEC_STATXACL_EXIT		10187
#define	hkwd_SEC_ACLXCNTL_ENTRY		10188
#define	hkwd_SEC_ACLXCNTL_EXIT		10189

#define	hkwd_SEC_CRED_CRGET		10300
#define	hkwd_SEC_CRED_CRFREE		10301
#define	hkwd_SEC_CRED_CRDUP		10302
#define	hkwd_SEC_CRED_CRHOLD		10303
#define	hkwd_SEC_CRED_CRREF		10304
#define	hkwd_SEC_CRED_CRCOPY		10305

#define hkwd_SEC_DATA1			1
#define hkwd_SEC_DATA2			2
#define hkwd_SEC_DATA3			3
#define hkwd_SEC_DATA4			4




/*
 *	HOOK ID's used by the PThreads instrumentation in
 *	"libpthreads.a".
 *
 */

#define HKWD_PTHREAD_SCHEDULER						0x60000000
#define HKWD_PTHREAD_TIMER							0x60300000
#define HKWD_PTHREAD_VPSLEEP						0x60500000
#define HKWD_PTHREAD_COND							0x60600000
#define HKWD_PTHREAD_MUTEX							0x60700000
#define HKWD_PTHREAD_SPINLOCK                                                   0x48E00000
#define HKWD_PTHREAD_BARRIER                                                    0x49600000
#define HKWD_PTHREAD_RWLOCK							0x60800000
#define HKWD_PTHREAD_GENERAL						0x60900000



/*
 *	Corresponding PThreads subhook declarations.
 *
 */

/* HKWD_PTHREAD_SCHEDULER subhooks.		*/
#define hkwd_PTHREAD_SCHED_KERN_SLEEP				   0x01
#define hkwd_PTHREAD_SCHED_KERN_AWAKE				   0x02
#define hkwd_PTHREAD_SCHED_YIELD					   0x03
#define hkwd_PTHREAD_SCHED_SLEEP					   0x04
#define hkwd_PTHREAD_SCHED_RUNQ_ADD					   0x05
#define hkwd_PTHREAD_SCHED_TIMESLICE_ENTRY			   0x06
#define hkwd_PTHREAD_SCHED_TIMESLICE_EXIT			   0x07
#define hkwd_PTHREAD_SCHED_TIMESLICE_EXIT_DISABLED	   0x08

/* HKWD_PTHREAD_TIMER subhooks.			*/
#define hkwd_PTHREAD_TIMER_SLEEP_NONEMPTY			   0x01
#define hkwd_PTHREAD_TIMER_SLEEP_EMPTY				   0x02
#define hkwd_PTHREAD_TIMER_AWAKE_NONEMPTY			   0x03
#define hkwd_PTHREAD_TIMER_AWAKE_EMPTY				   0x04

/* HKWD_PTHREAD_VPSLEEP subhooks.		*/
#define hkwd_PTHREAD_VPSLEEP_KERN_SLEEP				   0x01
#define hkwd_PTHREAD_VPSLEEP_KERN_AWAKE				   0x02
#define hkwd_PTHREAD_VPSLEEP_ENTRY					   0x03
#define hkwd_PTHREAD_VPSLEEP_EXIT					   0x04

/* HKWD_PTHREAD_COND subhooks.		*/
#define hkwd_PTHREAD_COND_INIT						   0x01
#define hkwd_PTHREAD_COND_DESTROY					   0x02
#define hkwd_PTHREAD_COND_WAIT_ENTRY				   0x03
#define hkwd_PTHREAD_COND_WAIT_EXIT					   0x04
#define hkwd_PTHREAD_COND_TIMEDWAIT_ENTRY			   0x05
#define hkwd_PTHREAD_COND_TIMEDWAIT_EXIT			   0x06
#define hkwd_PTHREAD_COND_SIGNAL					   0x07
#define hkwd_PTHREAD_COND_BROADCAST					   0x08

/* HKWD_PTHREAD_MUTEX subhooks.		*/
#define hkwd_PTHREAD_MUTEX_INIT						   0x01
#define hkwd_PTHREAD_MUTEX_DESTROY					   0x02
#define hkwd_PTHREAD_MUTEX_TAKEN_LOCAL				   0x03
#define hkwd_PTHREAD_MUTEX_TAKEN_GLOBAL				   0x04
#define hkwd_PTHREAD_MUTEX_MISS_LOCAL				   0x05
#define hkwd_PTHREAD_MUTEX_MISS_GLOBAL				   0x06
#define hkwd_PTHREAD_MUTEX_TRY_TAKEN_LOCAL			   0x07
#define hkwd_PTHREAD_MUTEX_TRY_TAKEN_GLOBAL			   0x08
#define hkwd_PTHREAD_MUTEX_TRY_MISS_LOCAL			   0x09
#define hkwd_PTHREAD_MUTEX_TRY_MISS_GLOBAL			   0x0A
#define hkwd_PTHREAD_MUTEX_RECURSIVE_TAKEN			   0x0B
#define hkwd_PTHREAD_MUTEX_RELEASE_LOCAL			   0x0C
#define hkwd_PTHREAD_MUTEX_RELEASE_GLOBAL			   0x0D
#define hkwd_PTHREAD_MUTEX_RECURSIVE_RELEASE		           0x0E
#define hkwd_PTHREAD_MUTEX_WAIT_LOCAL				   0x0F
#define hkwd_PTHREAD_MUTEX_WAIT_GLOBAL				   0x10
#define hkwd_PTHREAD_MUTEX_RUNQ_LOCK				   0x11
#define hkwd_PTHREAD_MUTEX_RUNQ_RELEASE				   0x12
#define hkwd_PTHREAD_MUTEX_BOOST				   0x13
#define hkwd_PTHREAD_MUTEX_UNBOOST				   0x14
#define hkwd_PTHREAD_MUTEX_CEILING_FAIL				   0x15
#define hkwd_PTHREAD_MUTEX_CAN_BOOST				   0x16
#define hkwd_PTHREAD_MUTEX_CAN_BOOST_LOCAL			   0x17
#define hkwd_PTHREAD_MUTEX_LOCAL_TIMEDOUT			   0x18
#define hkwd_PTHREAD_MUTEX_GLOBAL_TIMEDOUT			   0x19

/* HKWD_PTHREAD_RWLOCK subhooks.	*/
#define hkwd_PTHREAD_RWLOCK_INIT					   0x01
#define hkwd_PTHREAD_RWLOCK_DESTROY					   0x02
#define hkwd_PTHREAD_RWLOCK_UNLOCK					   0x03
#define hkwd_PTHREAD_RWLOCK_WRITE_TAKEN				   0x08
#define hkwd_PTHREAD_RWLOCK_WRITE_MISS				   0x09
#define hkwd_PTHREAD_RWLOCK_TRY_WRITE_TAKEN			   0x0A
#define hkwd_PTHREAD_RWLOCK_TRY_WRITE_MISS			   0x0B
#define hkwd_PTHREAD_RWLOCK_READ_TAKEN				   0x0C
#define hkwd_PTHREAD_RWLOCK_READ_MISS				   0x0D
#define hkwd_PTHREAD_RWLOCK_TRY_READ_TAKEN			   0x0E
#define hkwd_PTHREAD_RWLOCK_TRY_READ_MISS			   0x0F

/*
 * Posix Real Time Spinlocks
 * HKWD_PTHREAD_SPINLOCK subhooks
 */
#define hkwd_PTHREAD_SPINLOCK_INIT                                 0x01
#define hkwd_PTHREAD_SPINLOCK_DESTROY                              0x02
#define hkwd_PTHREAD_SPINLOCK_LOCK                                 0x03
#define hkwd_PTHREAD_SPINLOCK_TRYLOCK                              0x04
#define hkwd_PTHREAD_SPINLOCK_UNLOCK                               0x05

/*
 * Posix Real Time barriers
 * HKWD_PTHREAD_BARRIER subhooks
 */

#define hkwd_PTHREAD_BARRIER_INIT                                  0x01
#define hkwd_PTHREAD_BARRIER_DESTROY                               0x02
#define hkwd_PTHREAD_BARRIER_WAIT                                  0x03

/*	HKWD_PTHREAD_GENERAL subhooks.	*/
#define hkwd_PTHREAD_GEN_CREATE_ENTRY				   0x01
#define hkwd_PTHREAD_GEN_CREATE_EXIT_LOCAL			   0x02
#define hkwd_PTHREAD_GEN_CREATE_EXIT_GLOBAL			   0x03
#define hkwd_PTHREAD_GEN_EXIT						   0x04
#define hkwd_PTHREAD_GEN_KILL_ENTRY					   0x05
#define hkwd_PTHREAD_GEN_KILL_EXIT					   0x06
#define hkwd_PTHREAD_GEN_JOIN_ENTRY					   0x07
#define hkwd_PTHREAD_GEN_JOIN_EXIT					   0x08
#define hkwd_PTHREAD_GEN_DETACH_ENTRY				   0x09
#define hkwd_PTHREAD_GEN_DETACH_EXIT				   0x0A
#define hkwd_PTHREAD_GEN_CANCEL_ENTRY				   0x0B
#define hkwd_PTHREAD_GEN_CANCEL_EXIT				   0x0C
#define hkwd_PTHREAD_GEN_DISPATCH_ENTRY				   0x0D
#define hkwd_PTHREAD_GEN_DISPATCH_EXIT				   0x0E
#define hkwd_PTHREAD_GEN_ALLOCINITPTHREAD_ENTRY				0x0F
#define hkwd_PTHREAD_GEN_ALLOCINITPTHREAD_EXIT_GLOBAL			0x10
#define hkwd_PTHREAD_GEN_ALLOCINITPTHREAD_EXIT_LOCAL			0x11
#define hkwd_PTHREAD_GEN_SETSCHEDPRIO			                0x12

/* libc malloc trace hooks */
#define HKWD_LIBC_MALL_SUBSYSTEM                            0x60A00000

/* STAGE 0 */
#define hkwd_LIBC_MALL_MALLOC_COMMON_SIZE_ZERO              0x00
#define hkwd_LIBC_MALL_FREE_COMMON_NULL_PTR                 0x01
#define hkwd_LIBC_MALL_FREE_COMMON_OUT_OF_RANGE_PTR         0x02
#define hkwd_LIBC_MALL_FREE_COMMON_MEMALIGN_SUCCESS         0x03
#define hkwd_LIBC_MALL_FREE_COMMON_MEMALIGN_FAILURE         0x04
#define hkwd_LIBC_MALL_REALLOC_COMMON_NULL_PTR              0x05
#define hkwd_LIBC_MALL_REALLOC_COMMON_SIZE_ZERO             0x06
#define hkwd_LIBC_MALL_REALLOC_COMMON_OUT_OF_RANGE_PTR      0x07
#define hkwd_LIBC_MALL_REALLOC_COMMON_MEMALIGN_FAILED       0x08
#define hkwd_LIBC_MALL_REALLOC_COMMON_MEMALIGN_SUCCESS      0x09
#define hkwd_LIBC_MALL_MEMALIGN_COMMON_SIZE_ZERO            0x0A
#define hkwd_LIBC_MALL_MEMALIGN_COMMON_ALIGN_ERROR          0x0B
#define hkwd_LIBC_MALL_MEMALIGN_COMMON_ENOMEM               0x0C
#define hkwd_LIBC_MALL_MEMALIGN_COMMON_SUCCESS              0x0D

/* STAGE 1 */
#define hkwd_LIBC_MALL_MALLOC_CATCH_OVERFLOW_ENOMEM         0x10
#define hkwd_LIBC_MALL_MALLOC_CATCH_OVERFLOW_SUCCESS        0x11
#define hkwd_LIBC_MALL_FREE_CATCH_OVERFLOW_SUCCESS          0x12
#define hkwd_LIBC_MALL_REALLOC_CATCH_OVERFLOW_SUCCESS       0x13
#define hkwd_LIBC_MALL_REALLOC_CATCH_OVERFLOW_ENOMEM        0x14

/* STAGE 2 */
#define hkwd_LIBC_MALL_MALLOC_THREADCACHE_SUCCESS           0x20
#define hkwd_LIBC_MALL_FREE_THREADCACHE_SUCCESS             0x21

/* STAGE 3 */
#define hkwd_LIBC_MALL_MALLOC_HEAPCACHE_SUCCESS             0x20
#define hkwd_LIBC_MALL_FREE_HEAPCACHE_SUCCESS               0x21

/* STAGE 4 */
#define hkwd_LIBC_MALL_MALLOC_BUCKETS_SUCCESS_FREELIST      0x40
#define hkwd_LIBC_MALL_MALLOC_BUCKETS_SUCCESS_BUCKET        0x41
#define hkwd_LIBC_MALL_FREE_BUCKETS_SUCCESS                 0x43
#define hkwd_LIBC_MALL_FREE_BUCKETS_PREFIX_CORRUPTED        0x44
#define hkwd_LIBC_MALL_REALLOC_BUCKETS_SUCCESS              0x46
#define hkwd_LIBC_MALL_REALLOC_BUCKETS_PREFIX_CORRUPTED     0x47
#define hkwd_LIBC_MALL_MALLOC_NEWBUCKETS                    0x48
#define hkwd_LIBC_MALL_FREE_NEWBUCKETS                      0x49
#define hkwd_LIBC_MALL_REALLOC_NEWBUCKETS                   0x4A

/* STAGE 5 */
#define hkwd_LIBC_MALL_MALLOC_Y_SUCCESS                     0x50
#define hkwd_LIBC_MALL_MALLOC_Y_ENOMEM                      0x51
#define hkwd_LIBC_MALL_FREE_Y_SUCCESS                       0x52
#define hkwd_LIBC_MALL_FREE_Y_UNALIGNED                     0x54
#define hkwd_LIBC_MALL_FREE_Y_PREFIX_CORRUPTED              0x55
#define hkwd_LIBC_MALL_FREE_Y_INVALID_OVERLAP               0x56
#define hkwd_LIBC_MALL_REALLOC_Y_SUCCESS                    0x57
#define hkwd_LIBC_MALL_REALLOC_Y_ENOMEM                     0x58
#define hkwd_LIBC_MALL_REALLOC_Y_UNALIGNED                  0x5A
#define hkwd_LIBC_MALL_REALLOC_Y_PREFIX_CORRUPTED           0x5B

#define hkwd_LIBC_MALL_MALLOC_W_SUCCESS                     0x60
#define hkwd_LIBC_MALL_MALLOC_W_ENOMEM                      0x61
#define hkwd_LIBC_MALL_FREE_W_SUCCESS                       0x63
#define hkwd_LIBC_MALL_FREE_W_UNALIGNED                     0x64
#define hkwd_LIBC_MALL_FREE_W_PREFIX_CORRUPTED              0x65
#define hkwd_LIBC_MALL_FREE_W_INVALID_OVERLAP               0x66
#define hkwd_LIBC_MALL_REALLOC_W_SUCCESS                    0x68
#define hkwd_LIBC_MALL_REALLOC_W_ENOMEM                     0x69
#define hkwd_LIBC_MALL_REALLOC_W_UNALIGNED                  0x6A
#define hkwd_LIBC_MALL_REALLOC_W_PREFIX_CORRUPTED           0x6B

#define hkwd_LIBC_MALL_MALLOC_31                            0x70
#define hkwd_LIBC_MALL_MALLOC_31_ENOMEM                     0x71 
#define hkwd_LIBC_MALL_FREE_31                              0x72
#define hkwd_LIBC_MALL_FREE_31_PREFIX_CORRUPTED             0x73
#define hkwd_LIBC_MALL_REALLOC_31                           0x74
#define hkwd_LIBC_MALL_REALLOC_31_ENOMEM                    0x75

#define hkwd_LIBC_MALL_MALLOC_USER                          0x80
#define hkwd_LIBC_MALL_FREE_USER                            0x81
#define hkwd_LIBC_MALL_REALLOC_USER                         0x82

#define HKWD_LIBC_MALL_INTERNAL                             0x60B00000

/* STAGE 2 */
#define hkwd_LIBC_MALL_MALLOC_THREADCACHE_CREATE_FAILED     0x20
#define hkwd_LIBC_MALL_MALLOC_THREADCACHE_FILL_FAILED       0x21
#define hkwd_LIBC_MALL_MALLOC_THREADCACHE_FILL_SUCCESS      0x22
#define hkwd_LIBC_MALL_FREE_THREADCACHE_HALVE_BUCKET        0x24
#define hkwd_LIBC_MALL_FREE_THREADCACHE_NOCACHE             0x25

#define HKWD_POLLCACHE		0x52600000	   /* poll cache */

/* subhook ids */
#define hkwd_PC_PENDING			1
#define hkwd_PC_REMOVE_PEND		2
#define hkwd_PC_PUSH_PEND		3
#define hkwd_PC_TIME_OUT		4
#define hkwd_PC_WAIT_START		5
#define hkwd_PC_WAIT_STOP		6
#define hkwd_PC_CLEANUP_FD		7
#define hkwd_PC_POLL			8
#define hkwd_PC_CLOSE			9
#define hkwd_PC_REGISTER		10
#define hkwd_PC_UNREGISTER		11
#define hkwd_PC_INIT			12
#define hkwd_PC_RELEASE			13
#define hkwd_PC_CACHE_ADD		14
#define hkwd_PC_CLEANUP			15
#define hkwd_PC_DEQUEUE_PEND		16
#define hkwd_PC_ENQUEUE_PEND		17
#define hkwd_PC_WAIT2_START		18
#define hkwd_PC_WAIT2_STOP		19


/* loader trace hooks */
#define HKWD_LDR                	0x5A000000
#define hkwd_LDR_LOAD_FILE		0x01
#define hkwd_LDR_LOAD_LIBPATH		0x02
#define hkwd_LDR_LOADMODULE_COUNT	0x03
#define hkwd_LDR_PURGE			0x20
#define hkwd_LDR_UNLOADMODULE_COUNT	0x30
#define hkwd_LDR_LIB_LIBPATH_PRE	0x50
#define hkwd_LDR_LIB_LIBPATH		0x51
#define hkwd_LDR_LIB_LIB		0x52	
#define hkwd_LDR_GET_DOMAIN             0x70
#define hkwd_LDR_CLEAN_DOMAIN_ENTRY     0x71
#define hkwd_LDR_UNLOAD_DOMAIN          0x72
#define hkwd_LDR_LD_UNLOAD_LE_FILE	0x80
#define hkwd_LDR_LD_UNLOAD_LE_ADDR      0x81
#define hkwd_LDR_LIBGETTEXT_LOADLIST	0x152
#define hkwd_LDR_LIBGETTEXT_LOADLIST_LE	0x153
#define hkwd_LDR_LIBLD_LOADLIST		0x154
#define hkwd_LDR_LIBLD_LOADLIST_LE	0x155
#define hkwd_LDR_SROINST_LOADLIST	0x156
#define hkwd_LDR_SROINST_LOADLIST_LE	0x157
#define hkwd_LDR_INSTANCE_LOADLIST	0x158
#define hkwd_LDR_INSTANCE_LOADLIST_LE	0x159

#define HKWD_LDR_KMOD           	0x5A100000
#define hkwd_LDR_KMOD_LOAD_FILE		0x01
#define hkwd_LDR_KMOD_LOAD_LIBPATH	0x02
#define hkwd_LDR_KMOD_UNLOAD_FILE	0x03
#define hkwd_LDR_KMOD_LOAD_COUNT	0x04
#define hkwd_LDR_KMOD_UNLOAD_COUNT	0x05

#define HKWD_LDR_PROC           	0x5A200000
#define hkwd_LDR_PROC_FILE		0x01
#define hkwd_LDR_PROC_PID		0x02
#define hkwd_LDR_PROC_SID		0x03

#define HKWD_LDR_ERR            	0x5A300000
#define hkwd_LDR_ERR_LD_MOD		0x01
#define hkwd_LDR_ERR_KMOD_LOAD		0x02
#define hkwd_LDR_ERR_KMOD_UNLOAD	0x03
#define hkwd_LDR_ERR_EXECLOAD		0x04
#define hkwd_LDR_ERR_GET_DOMAIN		0x05
#define hkwd_LDR_ERR_RESOLVE_EBUF	0x06
#define hkwd_LDR_ERR_RESOLVE_REASON	0x07
#define hkwd_LDR_ERR_RELOCATE		0x08

#define HKWD_LDR_CHKPT			0x5A400000
#define hkwd_LDR_CHKPT_SID_32		0x01
#define hkwd_LDR_CHKPT_SID_64_TEXT	0x02
#define hkwd_LDR_CHKPT_SID_64_DATA	0x03
#define hkwd_LDR_CHKPT_LE_ADDR		0x04

/* trace hooks for MPIO path control modules */
#define HKWD_DD_PCMKE                   0x17B00000

/* POSIX Realtime clock */
#define HKWD_SYSC_RTCLOCK               0x5AA00000	
#define hkwd_SYSC_RTCLOCK_GETRES        0x01
#define hkwd_SYSC_RTCLOCK_GETTIME       0x02    
#define hkwd_SYSC_RTCLOCK_SETTIME       0x03
#define hkwd_SYSC_RTCLOCK_CPUCLOCKID    0x04
#define hkwd_SYSC_RTCLOCK_NANOSLEEP     0x05
#define hkwd_RTCLOCK_NANOSLEEP_END      0x06

/* POSIX Realtime timer */	
#define HKWD_SYSC_RTTIMER               0x5AB00000	
#define hkwd_SYSC_RTTIMER_CREATE        0x01
#define hkwd_SYSC_RTTIMER_DELETE        0x02
#define hkwd_SYSC_RTTIMER_GETOVERRUN    0x03
#define hkwd_SYSC_RTTIMER_GETTIME       0x04
#define hkwd_SYSC_RTTIMER_SETTIME       0x05
#define hkwd_RTTIMER_TRB_INTRVL_END     0x06
#define hkwd_RTTIMER_CPUTMR_INTRVL_END  0x07

/* Posix Realtime semaphores */
#define HKWD_SYSC_RTSEM                0x5B500000
#define hkwd_SYSC_RTSEM_OPEN           0x01
#define hkwd_SYSC_RTSEM_CLOSE          0x02
#define hkwd_SYSC_RTSEM_UNLINK         0x03
#define hkwd_SYSC_RTSEM_INIT           0x04
#define hkwd_SYSC_RTSEM_DESTROY        0x05
#define hkwd_SYSC_RTSEM_GETVALUE       0x06
#define hkwd_SYSC_RTSEM_POST           0x07
#define hkwd_SYSC_RTSEM_WAIT           0x08
#define hkwd_RTSEM_CREATE              0x09
#define hkwd_RTSEM_GET                 0x0A
#define hkwd_RTSEM_REMOVE              0x0B
#define hkwd_RTSEM_CLOSEDES            0x0C
/* Posix Real time message queues */ 
#define HKWD_SYSC_RTMQ                 0x5B600000 
#define hkwd_SYSC_RTMQ_OPEN            0x01 
#define hkwd_SYSC_RTMQ_CLOSE           0x02 
#define hkwd_SYSC_RTMQ_UNLINK          0x03 
#define hkwd_SYSC_RTMQ_GETATTR         0x04 
#define hkwd_SYSC_RTMQ_SETATTR         0x05 
#define hkwd_SYSC_RTMQ_NOTIFY          0x06 
#define hkwd_SYSC_RTMQ_SEND            0x07
#define hkwd_SYSC_RTMQ_RECEIVE         0x08 
#define hkwd_RTMQ_CREATE               0x09
#define hkwd_RTMQ_GET                  0x0A
#define hkwd_RTMQ_REMOVE               0x0B
#define hkwd_RTMQ_CLOSEDES             0x0C
/* Posix Real time shared memory */ 
#define HKWD_SYSC_RTSHM                0x5B700000 
#define hkwd_SYSC_RTSHM_OPEN           0x01 
#define hkwd_SYSC_RTSHM_UNLINK         0x02
#define hkwd_RTSHM_CREATE              0x03
#define hkwd_RTSHM_GET                 0x04
#define hkwd_RTSHM_REMOVE              0x05
#define hkwd_RTSHM_CLOSEDES            0x06
/* Posix Real time ipc name */
#define HKWD_RTIPC_NAME                0x5B800000
/* Posix Real time thread priority scheduling */
#define HKWD_SYSC_PRIO_REQUEUE         0x5AC00000
/* Posix Real time priority scheduling */
#define HKWD_SYSC_PRIO_SCHED             0x5AD00000
#define hkwd_PRIO_SCHED_GET_PRIORITY_MIN 0x01
#define hkwd_PRIO_SCHED_GET_PRIORITY_MAX 0x02
#define hkwd_PRIO_SCHED_RR_GET_INTERVAL  0x03
#define hkwd_PRIO_SCHED_SETPARAM         0x04
#define hkwd_PRIO_SCHED_SETSCHEDULER     0x05
#define hkwd_PRIO_SCHED_GETPARAM         0x06
#define hkwd_PRIO_SCHED_GETSCHEDULER     0x07


#define HKWD_NETWLM                             0x5B900000
#define hkwd_netwlm_connect_in                  1
#define hkwd_netwlm_connect_out                 2
#define hkwd_netwlm_connect_out_not_auth        3
#define hkwd_netwlm_connect_out_limit1_conn     4
#define hkwd_netwlm_connect_out_bad_version     5
#define hkwd_netwlm_disconnect_in               6
#define hkwd_netwlm_disconnect_out              7
#define hkwd_netwlm_disconnect_out_bad_version  8
#define hkwd_netwlm_disconnect_out_buffer_small 9
#define hkwd_netwlm_query_in                    10
#define hkwd_netwlm_query_out                   11
#define hkwd_netwlm_query_out_bad_request       12
#define hkwd_netwlm_set_ipaddrports_in          13
#define hkwd_netwlm_set_ipaddrports_out         14
#define hkwd_netwlm_set_ipaddrports_out_bad_version        15
#define hkwd_netwlm_get_ipaddrportsPID_in       16
#define hkwd_netwlm_get_ipaddrportsPID_out      17
#define hkwd_netwlm_proc_table_lookup_in        18
#define hkwd_netwlm_proc_table_lookup_out       19
#define hkwd_netwlm_fd_lookup_in                20
#define hkwd_netwlm_fd_lookup_out               21
#define hkwd_netwlm_get_proctable_lookup_in     22
#define hkwd_netwlm_get_proctable_lookup_out    23
#define hkwd_netwlm_get_verify_pid_in           24
#define hkwd_netwlm_get_verify_pid_out          25
#define hkwd_netwlm_get_fdlookup_in             26
#define hkwd_netwlm_get_fdlookup_out1           27
#define hkwd_netwlm_get_fdlookup_out2           28
#define hkwd_netwlm_get_fdlookup_out3           29
#define hkwd_netwlm_postbind_save_pid_in        30
#define hkwd_netwlm_postbind_save_pid_out       31
#define hkwd_netwlm_add_pid_in                  32
#define hkwd_netwlm_add_pid_out                 33
#define hkwd_netwlm_del_pid_in                  34
#define hkwd_netwlm_del_pid_out                 35
#define hkwd_netwlm_get_fdlookup_data1		36

#define HKWD_SEA			0x48F00000
#define hkwd_sea_config_in		0x01
#define hkwd_sea_cfg_lock_fail		0x02
#define hkwd_pincode_fail		0x03
#define hkwd_threadstart_fail		0x04
#define hkwd_uiomove_fail		0x05
#define hkwd_acs_found			0x06
#define hkwd_copyin_fail		0x07
#define hkwd_attach_sea_fail		0x08
#define hkwd_devtype_notsup		0x09
#define hkwd_attach_fail		0x0A
#define hkwd_nnd_open			0x0B
#define hkwd_nnd_ctl_promisc		0x0C
#define hkwd_nnd_ctl_addrchk		0x0D
#define hkwd_acs_notfound		0x0E
#define hkwd_detach_fail		0x0F
#define hkwd_sea_config_out		0x10
#define hkwd_attach_sea_succ		0x11
#define	hkwd_change_sea_in 		0x20
#define	hkwd_change_sea_notfound 	0x21
#define	hkwd_change_sea_out		0x22
#define	hkwd_list_sea_in 		0x23
#define	hkwd_list_sea_notfound 		0x24
#define	hkwd_list_sea_out		0x25
#define hkwd_sea_real_input_in		0x30
#define hkwd_sri_pktinfo		0x31
#define hkwd_sri_ours			0x32
#define hkwd_sri_bcast			0x33
#define hkwd_sri_bridged		0x34
#define hkwd_sea_real_input_out		0x35
#define hkwd_sea_input			0x40
#define hkwd_sea_thread			0x41
#define hkwd_sea_output_in		0x42
#define hkwd_sea_output_pktinfo		0x43
#define hkwd_sea_output_out		0x44
#define hkwd_sea_virt_input_in		0x50
#define hkwd_svi_pktinfo		0x51
#define hkwd_svi_ours			0x52
#define hkwd_svi_bcast			0x53
#define hkwd_svi_bridged		0x54
#define hkwd_sea_virt_input_out		0x55
#define hkwd_sea_frag_in		0x60
#define hkwd_sea_frag_out		0x61
#define hkwd_sea_frag_ip4_in		0x62
#define hkwd_sea_frag_ip4_data		0x63
#define hkwd_sea_frag_ip4_out		0x64
#define hkwd_sea_frag_ip6_in		0x65
#define hkwd_sea_frag_ip6_data		0x66
#define hkwd_sea_frag_ip6_out		0x67

/* trace hooks for memory locking routine */
#define HKWD_SYSC_MLOCK                 0x47B00000
#define hkwd_SYSC_MLOCK_LOCKALL         0x01
#define hkwd_SYSC_MLOCK_UNLOCKALL       0x02
#define hkwd_SYSC_MLOCK_LOCK            0x03
#define hkwd_SYSC_MLOCK_UNLOCK          0x04
#define hkwd_SYSC_MLOCK_FPGIN           0x05

/*
 * ACL Engine  hook and sub-hook ids
 */    
#define HKWD_ACLE                       0x47800000  
#define hkwd_ACLE_SET_ACL_ENTRY         0x01
#define hkwd_ACLE_SET_ACL_EXIT          0x02
#define hkwd_ACLE_VALIDATE_ACL          0x03
#define hkwd_ACLE_CHK_ACCESS_ENTRY      0x04
#define hkwd_ACLE_CHK_RWX               0x05
#define hkwd_ACLE_CHK_RWX_PRIVCHECK     0x06
#define hkwd_ACLE_CHK_MASKS             0x07
#define hkwd_ACLE_CHK_MASKS_PRIVCHECK   0x08
#define hkwd_ACLE_CHK_ONLY_PRIVCHECK    0x09
#define hkwd_ACLE_CHK_ACCESS_EXIT       0x0A
#define hkwd_ACLE_GET_ACL_ENTRY         0x0B
#define hkwd_ACLE_GET_ACL_EXIT          0x0C
#define hkwd_ACLE_GET_CHILD_ACL_ENTRY   0x0D
#define hkwd_ACLE_GET_CHILD_ACL_EXIT    0x0E

/*
 * Hypervisor Call hook and sub-hook ids
 */
#define HKWD_KERN_HCALL			0x49200000
#define hkwd_KERN_HCALL_START		1
#define hkwd_KERN_HCALL_END		2

/* Special defines for H_CEDE */
#define hkwd_KERN_HCEDE_START		1
#define hkwd_KERN_HCEDE_END_DC		2	/* Dispatch count changed */
#define hkwd_KERN_HCEDE_END_JOB		3	/* New job available	  */

/*
 * Advanced Accounting Trace Hooks.
 */
#define HKWD_AACCT			0x49A00000 /* AACCT - no _aacct_put */
#define HKWD_AACCT_DBG			0x49B00000 /* AACCT - _acct_put() */

/* subhook ids */

#define hkwd_AACCT_DR_HANDLER		1
#define hkwd_AACCT_INT_REGISTER		2
#define hkwd_AACCT_INT_REGISTER_EXIT	3
#define hkwd_AACCT_INT_UNREGISTER	4
#define hkwd_AACCT_INT_WALK		5
#define hkwd_AACCT_CMD_INT		6
#define hkwd_AACCT_CMD_ENABLE		7
#define hkwd_AACCT_CMD_DISABLE		8	

#define	hkwd_AACCT_REQ			9

#define hkwd_AACCT_STARTED		10
#define hkwd_AACCT_STOPPED		11
#define hkwd_AACCT_ADD_FILE		12
#define hkwd_AACCT_RM_FILE		13
#define hkwd_AACCT_SWITCH_FILE		14
#define hkwd_AACCT_ACK_FILE		15

#define hkwd_AACCT_TRID_DEFINED		16
#define hkwd_AACCT_TRID_ENABLED		17
#define hkwd_AACCT_TRID_DISABLED	18

#define hkwd_AACCT_ACF_FULL		19
#define hkwd_AACCT_ACF_TERMINATE	20
#define hkwd_AACCT_ACF_NOBUFS		21
#define hkwd_AACCT_ACF_NOFILES		22
#define hkwd_AACCT_ACF_WARN		23

#define hkwd_AACCT_SYSINT_SET		24
#define hkwd_AACCT_SYSINT_RESET		25
#define hkwd_AACCT_PROCINT_SET		26
#define hkwd_AACCT_PROCINT_RESET	27

#define hkwd_AACCT_AGGR_SET		28
#define hkwd_AACCT_AGGR_RESET		29


/* subhookid for HK_AACCT_DBG	*/

#define hkwd_AACCT_ACCTPUT		1
#define hkwd_AACCT_AGGR_PROC		2
#define hkwd_AACCT_AGGR_APP		3
#define hkwd_AACCT_AGGR_KE		4

/*
 * PCI Bus Driver's Hookwords.
 */
#define HKWD_KERN_EEH			0x49C00000  /* EEH Kernel Services */
#define HKWD_KERN_DMA			0x49D00000  /* DMA Kernel Services */

/* subhookids for HKWD_KERN_EEH */
#define EEH_INIT_ENTER			0x01
#define EEH_INIT_EXIT			0x0F
#define EEH_INIT_MULTIFUNC_ENTER	0x11
#define EEH_INIT_MULTIFUNC_EXIT		0x1F
#define EEH_CLEAR_ENTER			0x21
#define EEH_CLEAR_EXIT			0x2F
#define EEH_READ_SLOT_STATE1		0x34
#define EEH_READ_SLOT_STATE2		0x37
#define EEH_READ_SLOT_STATE_EXIT	0x3F
#define EEH_RESET_SLOT_ENTER		0x41
#define EEH_RESET_SLOT_RTAS		0x45
#define EEH_RESET_SLOT_EXIT		0x4F
#define EEH_ENABLE_SLOT_ENTER		0x51
#define EEH_ENABLE_SLOT_RTAS		0x55
#define EEH_ENABLE_SLOT_EXIT		0x5F
#define EEH_DISABLE_SLOT_ENTER		0x61
#define EEH_DISABLE_SLOT_RTAS		0x65
#define EEH_DISABLE_SLOT_EXIT		0x6F
#define EEH_ENABLE_DMA_ENTER		0x71
#define EEH_ENABLE_DMA_RTAS		0x75
#define EEH_ENABLE_DMA_EXIT		0x7F
#define EEH_ENABLE_PIO_ENTER		0x81
#define EEH_ENABLE_PIO_RTAS		0x85
#define EEH_ENABLE_PIO_EXIT		0x8F
#define EEH_SLOT_ERROR_ENTER		0x91
#define EEH_SLOT_ERROR_RTAS		0x95
#define EEH_SLOT_ERROR_RTAS2		0x97
#define EEH_SLOT_ERROR_EXIT		0x9F
#define EEH_CONFIGURE_BRIDGE_ENTER	0xA1
#define EEH_CONFIGURE_BRIDGE_RTAS	0xA5
#define EEH_CONFIGURE_BRIDGE_EXIT	0xAF
#define EEH_ISSUE_CALLBACKS_ENTER	0xB1
#define EEH_ISSUE_CALLBACKS_ENTER2	0xB2
#define EEH_ISSUE_CALLBACKS_MASTER	0xB5
#define EEH_ISSUE_CALLBACKS_RESTR	0xB6
#define EEH_ISSUE_CALLBACKS_KCALL	0xB8
#define EEH_ISSUE_CALLBACKS_UCALL	0xB9
#define EEH_ISSUE_CALLBACKS_RET		0xBA
#define EEH_ISSUE_CALLBACKS_EXIT	0xBF
#define EEH_CALL_FIRMWARE		0xC1

/*
 * VCM TRACE HOOKS 
 */
#define HKWD_VCM_MAIN  				0x48000000
#define hkwd_vcm_clientRegister_ENTER		0x001
#define hkwd_vcm_clientRegister_ERROR		0x002
#define hkwd_vcm_clientRegister_EXIT		0x003
#define hkwd_vcm_clientUnregister_ENTER		0x004
#define hkwd_vcm_clientUnregister_EXIT		0x005
#define hkwd_vcm_openVFS_ENTER			0x006
#define hkwd_vcm_openVFS_ERROR			0x007
#define hkwd_vcm_openVFS_EXIT			0x008
#define hkwd_vcm_closeVFS_ENTER			0x009
#define hkwd_vcm_closeVFS_EXIT			0x00a
#define hkwd_vcm_getOpRights_ENTER		0x00b
#define hkwd_vcm_getOpRights_ERROR1		0x00c
#define hkwd_vcm_getOpRights_ENTER2		0x00d
#define hkwd_vcm_getOpRights_ERROR2		0x00e
#define hkwd_vcm_getOpRights_EXIT1		0x00f
#define hkwd_vcm_returnOpRights_ENTER		0x010
#define hkwd_vcm_returnOpRights_EXIT		0x011
#define hkwd_vcm_beginCreate_ERROR		0x012
#define hkwd_vcm_beginCreate_ENTER		0x013
#define hkwd_vcm_beginCreate_EXIT2		0x014
#define hkwd_vcm_endCreate_ENTER		0x015
#define hkwd_vcm_endCreate_ERROR		0x016
#define hkwd_vcm_endCreate_EXIT1		0x017
#define hkwd_vcm_endCreate_EXIT2		0x018
#define hkwd_allocLocalObj_EXIT1    		0x019
#define hkwd_getLocalObj_ENTER    		0x01a
#define hkwd_getLocalObj_ERROR1    		0x01b
#define hkwd_getLocalObj_ERROR2    		0x01c
#define hkwd_getLocalObj_FINDLOCAL  		0x01d
#define hkwd_getLocalObj_EXIT  			0x01e
#define hkwd_localObjectRevoke_ENTER		0x01f
#define hkwd_localObjectRevoke_ERROR		0x020
#define hkwd_localObjectRevoke_CONFLICT_OPEN	0x021
#define hkwd_localObjectRevoke_CONFLICT_ACTIVE	0x022
#define hkwd_localObjectRevode_EXIT		0x023
#define hkwd_vcmi_localOpsInit_SIZES		0x024
#define hkwd_vcmi_localOpsInit_CLIENTADD	0x025
#define hkwd_vcm_localOpsGet_ENTER		0x026
#define hkwd_vcm_localOpsGet_ERROR		0x027
#define hkwd_vcm_localOpsGet_EXIT1		0x028
#define hkwd_vcm_localOpsGet_EXIT2		0x029
#define hkwd_vcm_localOpsPut_ENTER		0x02a
#define hkwd_vcm_localOpsPut_EXIT		0x02b
#define hkwd_vcm_localOpsOpen_ENTER		0x02c
#define hkwd_vcm_localOpsOpen_ERROR1		0x02d
#define hkwd_vcm_localOpsOpen_ERROR2		0x02e
#define hkwd_vcm_localOpsOpen_EXIT1		0x02f
#define hkwd_vcm_localOpsOpen_EXIT2		0x030
#define hkwd_vcm_localOpsClose_ENTER		0x031
#define hkwd_vcm_localOpsClose_ERROR1		0x032
#define hkwd_vcm_localOpsClose_ERROR2		0x033
#define hkwd_vcm_localOpsClose_ERROR4		0x035
#define hkwd_vcm_localOpsClose_ERROR5		0x036
#define hkwd_vcm_localOpsClose_ERROR6		0x037
#define hkwd_vcm_localOpsClose_EXIT		0x038
#define hkwd_vcm_localOpsBeginCreate_ENTER	0x039
#define hkwd_vcm_localOpsBeginCreate_NAME	0x03a
#define hkwd_vcm_localOpsBeginCreate_EXIT1	0x03b
#define hkwd_vcm_localOpsBeginCreate_EXIT2	0x03c
#define hkwd_vcm_localOpsEndCreate_ENTER	0x03d
#define hkwd_vcm_localOpsEndCreate_ERROR1	0x03e
#define hkwd_vcm_localOpsEndCreate_ERROR2	0x03f
#define hkwd_vcm_localOpsEndCreate_ERROR3	0x040
#define hkwd_vcm_localOpsEndCreate_ERROR4	0x041
#define hkwd_vcm_localOpsEndCreate_ERROR5	0x042
#define hkwd_vcm_localOpsEndCreate_EXIT1	0x043
#define hkwd_vcm_localOpsEndCreate_EXIT2	0x044
#define hkwd_vcm_init_EXIT_ERROR		0x045
#define hkwd_vcm_vnop_create_ENTER		0x046
#define hkwd_vcm_vnop_create_ERROR1		0x047
#define hkwd_vcm_vnop_create_ERROR2		0x048
#define hkwd_vcm_vnop_create_ERROR3		0x049
#define hkwd_vcm_vnop_create_EXIT		0x04a
#define hkwd_vcm_vnop_open_ERROR		0x04b
#define hkwd_vcm_vnop_create_attr_ENTER		0x04c
#define hkwd_vcm_vnop_create_attr_ERROR1	0x04d
#define hkwd_vcm_vnop_create_attr_ERROR2	0x04e
#define hkwd_vcm_vnop_create_attr_EXIT		0x04f
#define hkwd_chandleToClientRec_ERROR1		0x050
#define hkwd_chandleToClientRec_ERROR2		0x051
#define hkwd_vcmi_clientDelete_ERROR1		0x052
#define hkwd_vcmi_clientRevokeRights_ENTER1	0x053
#define hkwd_vcmi_clientRevokeRights_ENTER2	0x054
#define hkwd_vcmi_clientRevokeRights_EXIT	0x055
#define hkwd_vcmi_clientAddVFSOpen_ERROR1	0x056
#define hkwd_vcmi_clientAddVFSOpen_ERROR2	0x057
#define hkwd_vcmi_clientRemVFSOpen_ERROR1	0x058
#define hkwd_addVFS_ENTER			0x059
#define hkwd_closeVFS_ENTER			0x05a
#define hkwd_vcmi_vfsEndCreate_ERROR1		0x05b
#define hkwd_vcmi_vfsEndCreate_ERROR2		0x05c
#define hkwd_vcmi_vfsAddObjRef_ERROR1		0x05d
#define hkwd_vcmi_vfsAddObjRef_ERROR2		0x05e
#define hkwd_vcmi_vfsDelObjRef_ERROR1		0x05f
#define hkwd_vcmi_vfsDelObjRef_ERROR2		0x060
#define hkwd_vcmi_peerReturnObjHandle_ENTER	0x061
#define hkwd_vcmi_peerReturnObjHandle_EXIT	0x062
#define hkwd_vcmi_peerGetRights_ENTER		0x063
#define hkwd_vcmi_peerGetRights_EXIT1		0x064
#define hkwd_vcmi_peerGetRights_EXIT2		0x065
#define hkwd_vcmi_peerReturnRights_ENTER	0x066
#define hkwd_vcmi_peerReturnRights_EXIT		0x067
#define hkwd_vcmi_peerCreateObject_NAME		0x068
#define hkwd_vcmi_peerCreateObject_ENTER	0x069
#define hkwd_vcmi_peerCreateObject_EXIT		0x06a
#define hkwd_vcmi_peerOpenObject_ENTER		0x06b
#define hkwd_vcmi_peerOpenObject_EXIT		0x06c
#define hkwd_vcm_peerRegister_ENTER		0x06d
#define hkwd_vcm_peerRegister_ERROR1		0x06e
#define hkwd_vcm_peerRegister_EXIT		0x06f
#define hkwd_vcm_peerUnregister_ENTER		0x070
#define hkwd_vcm_peerUnregister_EXIT		0x071
#define hkwd_vcm_peerRevoke_ENTER		0x072
#define hkwd_vcm_peerRevoke_EXIT1		0x073
#define hkwd_removeRights_SUCCESS		0x074
#define hkwd_removeRights_TOPEER		0x075
#define hkwd_checkRevokeResponse_ERROR1		0x076
#define hkwd_checkRevokeResponse_ERROR2		0x077
#define hkwd_checkRevokeResponse_ERROR3		0x078
#define hkwd_checkRevokeResponse_ERROR4		0x079
#define hkwd_checkRevokeResponse_SETSTALE	0x07a
#define hkwd_objectRecGC_RESULTS		0x07b
#define hkwd_getHolder_NEW_HOLDER		0x07d
#define hkwd_getHolder_IS_LOCAL			0x07e
#define hkwd_getObjRec_NEWOBJ			0x07f
#define hkwd_objRecFromOpHandle_ERROR1		0x080
#define hkwd_getPeerRights_ERROR1		0x081
#define hkwd_resolveConflicts_INCREATE		0x082
#define hkwd_vcmi_rightsPeerRevoke_ERROR1	0x083
#define hkwd_vcmi_rightsPeerRevoke_ERROR2	0x084
#define hkwd_vcmi_rightsPeerRevoke_INCREATE	0x085
#define hkwd_vcmi_rightsFlushPeerState_ENTER	0x086
#define hkwd_vcmi_rightsFlushPeerState_EXIT	0x087
#define hkwd_vcmi_rightsGet_ESTALE		0x088
#define hkwd_vcmi_rightsPostCreate_ERROR	0x089
#define hkwd_vcmi_rightsFinishCreate_ERROR1	0x08a
#define hkwd_vcmi_rightsReturn_ERROR1		0x08b
#define hkwd_vcmi_rightsReturn_ERROR2		0x08c
#define hkwd_vcm_getOpRights_EXIT2		0x08d
#define hkwd_vcm_peerRevoke_EXIT2		0x08e
#define hkwd_vcm_beginCreate_EXIT1		0x08f
#define hkwd_localObjectRevoke_ERROR2		0x090
#define hkwd_vcm_localOpsClose_ERROR7		0x091
#define hkwd_objectRecGC_ENTER			0x092
#define hkwd_getHolder_OLD_RTAG			0x093
#define hkwd_vcmi_rightsGet_ENTER		0x094
#define hkwd_vcmi_rightsGet_BAD_RTAG		0x095
#define hkwd_vcmi_rightsGet_EXIT		0x096
#define hkwd_allocObj_ERROR_GCD			0x097

#define HKWD_VCM_DEBUG    			0x48100000
#define hkwd_releaseLocalObj_RETURN1		0x001
#define hkwd_releaseLocalObj_RETURN2		0x002
#define hkwd_releaseLocalObj_EXIT1		0x003
#define hkwd_releaseLocalObj_EXIT2		0x004
#define hkwd_getLocalRights_EXIT		0x005
#define hkwd_vcm_localOpsPut_ERROR		0x006
#define hkwd_findVFS_EXIT			0x007
#define hkwd_remVFS_ENTER			0x008
#define hkwd_vcmi_peerFind_RESULTS		0x009
#define hkwd_vcmi_peerGetObjHandle_ENTER	0x00a
#define hkwd_vcmi_peerGetObjHandle_EXIT1	0x00b
#define hkwd_vcmi_peerGetObjHandle_EXIT2	0x00c
#define hkwd_allocObj_STATS			0x00d
#define hkwd_getLocalRights_ENTER		0x00e
#define hkwd_getLocalRights_EXIT_ERROR		0x00f
#define hkwd_localObjectRevoke_INVALID_ERROR	0x010
#define hkwd_objectRecGC_STATS			0x011

#endif /* _H_TRCHKID */
